using namespace std;
#include <cstdlib>
#include <iostream>
#include <exception>
#include <sstream>
#include "tmdexception.h"

using namespace TMDplotter;

TMDexception::TMDexception(std::string s, int i) : description(s), line(i) {}
Unknownparton::Unknownparton(std::string s, int i) : TMDexception(s, i) {}
Computation::Computation(std::string s, int i) : TMDexception(s, i) {}
Notimplemented::Notimplemented(std::string s, int i) :TMDexception(s, i) {}
UndefinedPDF::UndefinedPDF(std::string s, int i) :TMDexception(s, i) {}
Unknownevolution::Unknownevolution(std::string s, int i) :TMDexception(s, i) {}
/*
 *
 * For explanation of the exception types, read he header file!
 *
 */
const char * Computation::what() const throw() {
    std::ostringstream errormessage;
    errormessage << "Line: " << line << "\tComputation: " << description;
    return errormessage.str().c_str();
}
const char * Unknownparton::what() const throw() {
    std::ostringstream errormessage;
    errormessage << "Line: " << line << "\tUnknown parton: " << description;
    return errormessage.str().c_str();
}
const char * Notimplemented::what() const throw() {
    std::ostringstream errormessage;
    errormessage << "Line: " << line << "\tFunction not implemented yet: " << description;
    return errormessage.str().c_str();
}
const char * UndefinedPDF::what() const throw() {
    std::ostringstream errormessage;
    errormessage << "Line: " << line << "\tPDF not defined: " << description;
    return errormessage.str().c_str();
}
const char * Unknownevolution::what() const throw() {
    std::ostringstream errormessage;
    errormessage << "Line: " << line << "\tUnknown evolution equation or PDF set: " << description;
    return errormessage.str().c_str();
}
