#ifndef TMDEXCEPTION_H
#define TMDEXCEPTION_H
// standard
#include <cstdlib>
#include <iostream>
#include <exception>
#include <sstream>

namespace TMDplotter {
class TMDexception : public std::exception // abstract 'parent' exception for all TMD-related exceptions
{
public:
    TMDexception(std::string s, int i);
    virtual ~TMDexception() throw() {}
    virtual const char * what() const throw() =0;
protected:
    std::string description;
    int line;
};

class Computation : public TMDexception
{
public:
    Computation(std::string s, int i);
    virtual ~Computation() throw() {}
    virtual const char * what() const throw();
};
class Unknownparton : public TMDexception // This exception is thrown when the user tried to get a PDF for a prton that is not known to the program
{
public:
    Unknownparton(std::string s, int i);
    virtual ~Unknownparton() throw() {}
    virtual const char * what() const throw();
};

class Notimplemented : public TMDexception // This exception is thrown when the user tried to acces a function that is not implemented yet
{
public:
    Notimplemented(std::string s, int i);
    virtual ~Notimplemented() throw() {}
    virtual const char * what() const throw();
};

class UndefinedPDF : public TMDexception // This exception is thrown when the user tried to get a PDF that is not known to the program
{
public:
    UndefinedPDF(std::string s, int i);
    virtual ~UndefinedPDF() throw() {}
    virtual const char * what() const throw();
};

class Unknownevolution : public TMDexception // This exception is thrown when the user tried to get a PDF from an evolution family that is not known to the program
{
public:
    Unknownevolution(std::string s, int i);
    virtual ~Unknownevolution() throw() {}
    virtual const char * what() const throw();
};
}
#endif
