#include "tmdlib/TMDlib.h"
#include <fstream>
#include <iomanip>
using namespace TMDlib;
extern std::string pdfpath;
int icount =0 ;
TMD::TMD(void) {
    icount = icount + 1;
    // std::cout << "TMD object is being created " << icount << std::endl;

}

int main(int argc, char **argv) {


    std::string name ;
    //name = "GBWlight";
    //name ="ccfm-JH-2013-set1";
    //name ="PB-NLO-HERAI+II-2018-set1";
    //name ="KS-2013-linear";
    //name ="KS-2013-linear";
    //name ="KS-2013-non-linear";
    //name ="PB-nCTEQ15FullNuc_208_82-set2";
    //name ="EKMP";
    //name ="PV17_grid_pdf";
    name ="SV19_nnlo";

    if (argc>2) { pdfpath = argv[1]; name = std::string(argv[2]);}

    // name ="PB-NLO-4FL-HERAI+II-2020-set2";

    double x, xbar, kt, mu;
    double mz = 91.18;
    double uval, dval, sea, charm, bottom, gluon;

    x = 0.01 ;
    xbar = 0 ;
    kt = 10. ;
    mu = 100 ;

    x = 0.15 ;
    xbar = 0 ;
    kt = 1. ;
    mu = 10 ;

//  x=1.E-6 ;
//  kt=14.;
//  mu=6.;

    //std::shared_ptr<TMD> test = std::make_shared<TMD>();
    
    TMD test ;
    test.setVerbosity(99);

    int irep=0;
    test.TMDinit(name,irep);
    if (argc>2) { pdfpath = argv[1]; name = std::string(argv[2]);}
//  int iset = 102134 ;
//  test.TMDinit(iset);

    std::cout << "TMDSet Description: " << test.TMDgetDesc() << std::endl;
    std::cout << "Order alphas = " << test.TMDgetOrderAlphaS() << std::endl;
    // std::cout << "qcdlam4      = " << test.TMDgetLam4() << std::endl;
    std::cout << "order PDF    = " << test.TMDgetOrderPDF() << std::endl;

    std::cout << "xmin         = " << test.TMDgetXmin() << std::endl;
    std::cout << "xmax         = " << test.TMDgetXmax() << std::endl;
    std::cout << "q2min        = " << test.TMDgetQ2min() << std::endl;
    std::cout << "q2max        = " << test.TMDgetQ2max() << std::endl;
    std::cout << "num flav     = " << test.TMDgetNf() << std::endl;
    std::cout << "number       = " << test.TMDnumberPDF(name) << std::endl;

    std::cout << std::endl;


    std::vector<double> arr(14);
    double* xpq = &arr[6];

    if (argc==1)  test.TMDpdf(x,xbar,kt,mu, arr);
    std::cout << " TMDlib: xu(x,mu) = " << xpq[2] << " xd(x,mu) = " << xpq[1] << " xg(x,mu) =  " << xpq[0] << std::endl;
    return 0;
}
