//
// Author: Valerio Bertone: valerio.bertone@cern.ch
//

#ifndef TMDLIB_NUMTOSTRING_H
#define TMDLIB_NUMTOSTRING_H

#include <string>

namespace TMDlib
{
/**
 * @brief Function that, given an integer 'i', outputs a string
 * version of 'i' of length 'len' preceeded by as many zeros as
 * needed to reach lenght 'len'.
 * @param i: number to transform in string
 * @param len: length of the std::string (default: 4)
 */
std::string num_to_string(int const& i, int const& len = 4)
{
    std::string str = std::to_string(i);
    const int bf = len - str.size();
    if (bf < 0)
        throw std::runtime_error("[num_to_string]: The input integer exceeds the std::string length.");
    for (int j = 0; j < bf; j++)
        str = "0" + str;
    return str;
}
}
#endif
