#include "tmdlib/TMDlib.h"

#include <iostream>
#include <sstream>
#include <string>
#include <fstream>
#include <math.h>

using namespace TMDlib;
/* Common Block Declarations */

extern bool first;

void TMD::tmd_ME(double x, double kt, double p, double& uval, double& dval, double& sea, double& charm, double& bottom, double& glu)

{

    if (first) {

        //cout <<  " TMD gluon from M. Echhevarria " << endl;
        //cout << " kf = " << kf << " x = " <<x << " kt = " << kt <<endl;
        first = false ;
//=================================================================
//      call alpha_strong - see the description on kernel_g.f
//=================================================================
        int iord_alpha ;
        double fr2, mur, asmur, mc_mstw, mb_mstw, mt_mstw ;
        iord_alpha = 3 ;      // perturbative order (N^mLO,m=0,1,2,3)
        //iord_alpha = 1 ;      // perturbative order (N^mLO,m=0,1,2,3)
        fr2 = 1.  ;         // ratio of mu_f^2 to mu_r^2
        mur = 91.19 ;       // input mu_r in GeV
        asmur = 0.1185 ;    // input value of alpha_s at mu_r (PDG2014)
        mc_mstw = 1.4 ;     // charm quark mass
        mb_mstw = 4.75 ;    // bottom quark mass
        mt_mstw = 1.e10 ;     // top quark mass
        initalphas( &iord_alpha, &fr2,&mur,&asmur,&mc_mstw,&mb_mstw,&mt_mstw) ;

    }

    double kt_ME = kt ;
    double x_ME = x ;
    double scale = 1.;
    double scale2 = 1.;
    double result = 0;
    double bc = 1.5;
    double Qf  = p;
    //double lam1=0.05, lam2=0.05 ;
    double lam1=0.5, lam2=0.5 ;
    int inp = 2;
    //int inp = 1;
    // Qf = scale p
    // scale,scale2 are ratios of mu/Qf and zeta/Qf
    // lam1, lam2 are free non-pert paramters
    if ( kt < 2 * p ) {
// inserted by Hannes to avoid fluctuations at large kt
        unpol(&inp,&scale,&scale2,&bc,&lam1,&lam2,&x_ME,&kt_ME,&Qf,&result) ;
    }
    else { result = 0;}
    //cout << " tmd_ME: after unpol " << result << endl;
    //glu = result * x_ME;
    // divide by pi to obtain the same value as in REF workshop report 1507.05267
    glu = result/3.1415 ;

    return ;
}

