      BLOCK DATA
      IMPLICIT DOUBLE PRECISION(A-Z)
      data c0/1.122919d0/c02/1.260947d0/ ! c02=c0^2, c0=2*exp(-\gamma_E)
      data pi/3.1415926535d0/CF/1.333333d0/CA/3d0/mc/1.4d0/mb/4.75d0/
      data lambda3/0.340/lambda4/0.297d0/lambda5/0.214d0/ ! From PDG2013
      common /cons/c0,c02,pi,CF,CA,mc,mb,lambda3,lambda4,lambda5
      end

C----------------------------------------------------------------------
C       Unpolarized gluon TMDPDF in momentum space
C----------------------------------------------------------------------
      subroutine unpol(order,sca,sca2,bcc,lamm1,lamm2,x,k,Q,res)
      implicit none
      real*8 k,kT,qgauss,x,xb,bc,Qi,Q,Qf,b,upv,res,b0,bcc
      real*8 sca,sca2
      real*8 tmd_ips,aspi,scale,scale2,lamm1,lamm2,lam1,lam2
      real*8 bmin,tmd_ipss
      integer ngauss,order,nf
      common /vars/ xb,kT,Qi,Qf
      common /nonpert/ bc,lam1,lam2
      common /sc/ scale,scale2
      integer ord
      common /iorder/ord
      real*8 c0,c02,pi,CF,CA,mc,mb,lambda3,lambda4,lambda5
      common /cons/c0,c02,pi,CF,CA,mc,mb,lambda3,lambda4,lambda5
      external tmd_ips,tmd_ipss,aspi
c      write(6,*) c0,c02,pi,CF,CA,mc,mb,lambda3,lambda4,lambda5
      ord   = order
      xb    = x
      kT    = k
      Qf    = Q
      scale = sca
      scale2= sca2
      bc    = bcc
      lam1  = lamm1
      lam2  = lamm2

      bmin = 1d-5
      ngauss=4  ! 4 steps should be enough, but better check it...
c      write(6,*) ord,xb,kT,Qf,scale,scale2,bc,lam1,lam2,bmin
      res=qgauss(tmd_ips,bmin,15d0,ngauss)
      bmin = 1d-15
      ngauss=10
      res=qgauss(tmd_ips,bmin,15d0,ngauss)
C-----We integrate up to b=15, which is enough for Q=5, I checked it below
C     by plotting the integrand. For larger Q, is much more than enough.
cc      write(6,*) ' res ',res
c     If we want to get the TMD in impact parameter space:
c      res=tmd_ips(k)

      return
      end

C----------------------------------------------------------------------
C       INTEGRAND of helicity gluon TMDPDF in impact parameter space
C----------------------------------------------------------------------
      function tmd_ips(b)
      implicit none
      real*8 bessel0,xb,Qi,Qi2,Qf,kT,b,gpdf,getonepdf,alf
      real*8 DUV,DDV,DUBAR,DDBAR,DST,DGL
      real*8 tmd_ips,aspi,scale,scale2,sc2,bc,bb
      real*8 qgauss,bi,bhat
      real*8 resexpgF,resDR,reshgR,reshggR,lperp,lam1,lam2,lam
      integer ngauss,iset,i
c      CHARACTER prefix*100
      CHARACTER prefix*200
      common /vars/ xb,kT,Qi,Qf
      common /nonpert/ bc,lam1,lam2
      common /sc/ scale,scale2
      integer ord
      common /iorder/ord
      real*8 c0,c02,pi,CF,CA,mc,mb,lambda3,lambda4,lambda5
      common /cons/c0,c02,pi,CF,CA,mc,mb,lambda3,lambda4,lambda5
      real*8 resU1,resD1,resUB1,resDB1,resSS1,resSB1,resGL1
      common /convolutions/ resU1,resD1,resSS1,resUB1,resDB1,resSB1,
     >                      resGL1
      common/varb/bi
      
      
c      INCLUDE  '../../include/TMDlibPDFpath.inc'
      INCLUDE   'TMDlibPDFpath.inc'
      INTEGER PDFPATHLEN
      
c
c     We define the bhat prescription
c
      bhat = bc*(1d0-dexp(-(b/bc)**2d0))**(1d0/2d0)
      bi = bhat
      sc2 = scale2

      Qi = scale*c0/bhat
            
      Qi2 = Qi*Qi

      if (Qi.le.1d0) then
        Qi  = 1d0
        Qi2 = 1d0
      endif


      iset=0
c     we always set PDFs at NNLO
c      write(6,*) ' tmd_ips pdfpath:',pdfpath
      PDFPATHLEN=INDEX(PDFPATH,' ')-1
      if (ord .eq. 0) then ! LL
         prefix = PDFPATH(1:PDFPATHLEN)//'EKMP/mstw2008nnlo'
      elseif (ord .eq. 1) then ! NLL
         prefix = PDFPATH(1:PDFPATHLEN)//'EKMP/mstw2008nnlo'
      else if (ord .eq. 2) then ! NNLL
         prefix = PDFPATH(1:PDFPATHLEN)//'EKMP/mstw2008nnlo'
      end if

      gpdf=GetOnePDF(prefix,iset,xb,Qi,0)/xb
 
      if(ord.eq.0) then     ! LL
        call expgammaF(Qi,Qf,resexpgF)
c        call DR(bhat,Qi,resDR)
c        call hgR(bhat,Qi,reshgR)
c        call hggR(bhat,Qi,reshggR)
        call DRfixed(bhat,Qi,resDR)
            tmd_ips = (1/2d0/pi)*b*bessel0(b*kT)
     $       *resexpgF*dexp(-resDR*dlog(Qf*Qf*bhat*bhat/c02/sc2/sc2))
c     $       *dexp(reshggR-reshgR)
     $       *gpdf
     $       *dexp((-lam1-lam2*dlog(Qf*Qf))*b*b)

      elseif(ord.eq.1) then     ! NLL
        call expgammaF(Qi,Qf,resexpgF)
c        call DR(bhat,Qi,resDR)
c        call hgR(bhat,Qi,reshgR)
c        call hggR(bhat,Qi,reshggR)
        call DRfixed(bhat,Qi,resDR)
            tmd_ips = (1/2d0/pi)*b*bessel0(b*kT)
     $        *resexpgF*dexp(-resDR*dlog(Qf*Qf*bhat*bhat/c02/sc2/sc2))
c     $        +reshggR-reshgR)
     $        *gpdf
     $        *dexp((-lam1-lam2*dlog(Qf*Qf))*b*b)

      elseif(ord.eq.2) then     ! NNLL
        call expgammaF(Qi,Qf,resexpgF)
c        call DR(bhat,Qi,resDR)
c        call hgR(bhat,Qi,reshgR)
c        call hggR(bhat,Qi,reshggR)
        call DRfixed(bhat,Qi,resDR)
        call convol_Z
        lperp=dlog(Qi*Qi*bhat*bhat/c02)
        alf = 2*aspi(Qi)
            tmd_ips = (1/2d0/pi)*b*bessel0(b*kT)
     $        *resexpgF*dexp(-resDR*dlog(Qf*Qf*bhat*bhat/c02/sc2/sc2))
c     $        +reshggR-reshgR)
     $        *(gpdf
     $        +alf*(resU1+resD1+resSS1
     $        +resUB1+resDB1+resSB1+resGL1))
     $        *dexp((-lam1-lam2*dlog(Qf*Qf))*b*b)
      endif

      goto 234
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
c   CHECK OF THE INTEGRAND: to see its extension and fix the b integration
c
        ord = 2
        lam1 = 0.05
        lam2 = 0.05
        kT  = 2d0
        sc2 = 1d0

        b = 0.0000001d0
        do i=1,60

        call expgammaF(Qi,Qf,resexpgF)
        call DRfixed(bhat,Qi,resDR)
        call convol_Z
        lperp=dlog(Qi*Qi*bhat*bhat/c02)
        alf = 2*aspi(Qi)
          gpdf=DGL
            tmd_ips =
c     $        (1/2d0/pi)*b*bessel0(b*kT)*
     $        resexpgF*dexp(-resDR*dlog(Qf*Qf*bhat*bhat/c02/sc2/sc2))
     $        *((gpdf/xb)
     $        +alf*(resU1+resD1+resSS1
     $        +resUB1+resDB1+resSB1+resGL1))
     $        *dexp((-lam1-lam2*dlog(Qf*Qf))*b*b)

        write(127,*) b,tmd_ips
cccc        write(6,*) 'b, tmd_ips', b,tmd_ips
        b = b + 0.1

        enddo

        stop
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
234   continue 


      return
      end




c--------------------------------------------------------------
c     OPE convolutions
c--------------------------------------------------------------
      subroutine convol_Z
      implicit none
      real*8 rts,b,kT,Qi,Qf,xb,res,beta0
      real*8 x1,x2,qgauss,lperp,bi
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      real*8 U2,D2,UB2,DB2,SS2,SB2,GL2
      real*8 term_p_u,term_p_d,term_p_s,term_p_ub,
     >       term_p_db,term_p_sb,term_p_g,term_p_g1,
     >       term_p_u1,term_p_d1,term_p_s1,term_p_ub1,
     >       term_p_db1,term_p_sb1
      integer steps,nf
      common /vars/ xb,kT,Qi,Qf
      real*8 resU1,resD1,resUB1,resDB1,resSS1,resSB1,resGL1
      common /convolutions/ resU1,resD1,resSS1,resUB1,resDB1,resSB1,
     >                      resGL1
      external term_p_u,term_p_d,term_p_s,term_p_ub,
     >         term_p_db,term_p_sb,term_p_g,term_p_g1,
     >         term_p_u1,term_p_d1,term_p_s1,term_p_ub1,
     >         term_p_db1,term_p_sb1
      real*8 c0,c02,pi,CF,CA,mc,mb,lambda3,lambda4,lambda5
      common /cons/c0,c02,pi,CF,CA,mc,mb,lambda3,lambda4,lambda5
      integer ord
      common /iorder/ord
      common/varb/bi
      real*8 scale,scale2,sc2
      common /sc/ scale,scale2


C-----steps=4 seems to be more than enough!
      steps=4

      if(Qi.le.mc) then
        nf=3
      elseif(Qi.gt.mc.and.Qi.le.mb) then
        nf=4
      elseif(Qi.gt.mb) then
        nf=5
      endif
      beta0 = 11d0-2d0*nf/3d0

      lperp=dlog(Qi*Qi*bi*bi/c02)
      sc2 = scale2


C-----Convolutions for the proton
      call PDF_p(xb,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      resU1 = -CF*lperp*qgauss(term_p_u,xb,1d0,steps)
     $        +CF*qgauss(term_p_u1,xb,1d0,steps)
      resD1 = -CF*lperp*qgauss(term_p_d,xb,1d0,steps)
     $        +CF*qgauss(term_p_d1,xb,1d0,steps)
      resSS1= -CF*lperp*qgauss(term_p_s,xb,1d0,steps)
     $        +CF*qgauss(term_p_s1,xb,1d0,steps)
      resUB1= -CF*lperp*qgauss(term_p_ub,xb,1d0,steps)
     $        +CF*qgauss(term_p_ub1,xb,1d0,steps)
      resDB1= -CF*lperp*qgauss(term_p_db,xb,1d0,steps)
     $        +CF*qgauss(term_p_db1,xb,1d0,steps)
      resSB1= -CF*lperp*qgauss(term_p_sb,xb,1d0,steps)
     $        +CF*qgauss(term_p_sb1,xb,1d0,steps)
      resGL1= -2d0*CA*lperp*(qgauss(term_p_g,xb,1d0,steps)
     $        +qgauss(term_p_g1,xb,1d0,steps)+GL1*dlog(1d0-xb))
c     $        -lperp*beta0/2d0*GL1
     $        -CA*pi*pi/12d0*GL1
     $        +CA*0.5d0*lperp*lperp*GL1
     $        -CA*lperp*dlog(sc2*sc2)*GL1

      return
      end



c--------------------------------------------------------------
c     Integrand of one term of the OPE coefficient for gluon to gluon.
c     PDF of gluon in proton
c     (1/(1-z))*(f_g(xa/z)-f_g(xa))
c--------------------------------------------------------------
      function term_p_g(z)
      implicit none
      real*8 term_p_g,kT,Qi,Qf,z,z1,xb
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1,GL2
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      z1=xb
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL2)
      term_p_g=1d0/(1d0-z)*(GL1-GL2)

      return
      end

c--------------------------------------------------------------
c     Integrand of another term of the OPE coefficient for gluon to gluon.
c     PDF of gluon in proton
c     (((1-z)*(1+z^2)-(1-z)^3)/(z^2))*g1(xa/z)
c--------------------------------------------------------------
      function term_p_g1(z)
      implicit none
      real*8 term_p_g1,kT,Qi,Qf,z,z1,xb
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1,GL2
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_g1=((1d0-z)*(1d0+z*z))/(z*z)*GL1

      return
      end

c--------------------------------------------------------------
c     Integrand of one term of the OPE coefficient
c     PDF of u quark in proton
c     (1-(1-z)^2)/z^2*Dq(xb/z)
c--------------------------------------------------------------
      function term_p_u(z)
      implicit none
      real*8 term_p_u,xb,kT,Qi,Qf,z,z1
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_u=(1d0+(1d0-z)**2d0)/(z*z)*U1

      return
      end

c--------------------------------------------------------------
c     Integrand of one term of the OPE coefficient
c     PDF of d quark in proton
c     (1-(1-z)^2)/(z*z)*Dq(xb/z)
c--------------------------------------------------------------
      function term_p_d(z)
      implicit none
      real*8 term_p_d,xb,kT,Qi,Qf,z,z1
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_d=(1d0+(1d0-z)**2d0)/(z*z)*D1

      return
      end

c--------------------------------------------------------------
c     Integrand of one term of the OPE coefficient
c     PDF of s quark in proton
c     (1-(1-z)^2)/(z*z)*Dq(xb/z)
c--------------------------------------------------------------
      function term_p_s(z)
      implicit none
      real*8 term_p_s,xb,kT,Qi,Qf,z,z1
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_s=(1d0+(1d0-z)**2d0)/(z*z)*SS1

      return
      end

c--------------------------------------------------------------
c     Integrand of one term of the OPE coefficient
c     PDF of u antiquark in proton
c     (1-(1-z)^2)/(z*z)*Dq(xb/z)
c--------------------------------------------------------------
      function term_p_ub(z)
      implicit none
      real*8 term_p_ub,xb,kT,Qi,Qf,z,z1
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_ub=(1d0+(1d0-z)**2d0)/(z*z)*UB1

      return
      end

c--------------------------------------------------------------
c     Integrand of one term of the OPE coefficient
c     PDF of d antiquark in proton
c     (1-(1-z)^2)/(z*z)*Dq(xb/z)
c--------------------------------------------------------------
      function term_p_db(z)
      implicit none
      real*8 term_p_db,xb,kT,Qi,Qf,z,z1
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_db=(1d0+(1d0-z)**2d0)/(z*z)*DB1

      return
      end

c--------------------------------------------------------------
c     Integrand of one term of the OPE coefficient
c     PDF of s antiquark in proton
c     (1-(1-z)^2)/(z*z)*Dq(xb/z)
c--------------------------------------------------------------
      function term_p_sb(z)
      implicit none
      real*8 term_p_sb,xb,kT,Qi,Qf,z,z1
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_sb=(1d0+(1d0-z)**2d0)/(z*z)*SB1

      return
      end

c--------------------------------------------------------------
c     Integrand of another term of the OPE coefficient
c     PDF of u quark in proton
c     Dq(xb/z)
c--------------------------------------------------------------
      function term_p_u1(z)
      implicit none
      real*8 term_p_u1,xb,kT,Qi,Qf,z,z1
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_u1=U1

      return
      end

c--------------------------------------------------------------
c     Integrand of another term of the OPE coefficient
c     PDF of d quark in proton
c     Dq(xb/z)
c--------------------------------------------------------------
      function term_p_d1(z)
      implicit none
      real*8 term_p_d1,xb,kT,Qi,Qf,z,z1
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_d1=D1

      return
      end

c--------------------------------------------------------------
c     Integrand of another term of the OPE coefficient
c     PDF of s quark in proton
c     Dq(xb/z)
c--------------------------------------------------------------
      function term_p_s1(z)
      implicit none
      real*8 term_p_s1,xb,kT,Qi,Qf,z,z1
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_s1=SS1

      return
      end

c--------------------------------------------------------------
c     Integrand of another term of the OPE coefficient
c     PDF of u antiquark in proton
c     Dq(xb/z)
c--------------------------------------------------------------
      function term_p_ub1(z)
      implicit none
      real*8 term_p_ub1,xb,kT,Qi,Qf,z,z1
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_ub1=UB1

      return
      end

c--------------------------------------------------------------
c     Integrand of another term of the OPE coefficient
c     PDF of d antiquark in proton
c     Dq(xb/z)
c--------------------------------------------------------------
      function term_p_db1(z)
      implicit none
      real*8 term_p_db1,xb,kT,Qi,Qf,z,z1
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_db1=DB1

      return
      end

c--------------------------------------------------------------
c     Integrand of another term of the OPE coefficient
c     PDF of s antiquark in proton
c     Dq(xb/z)
c--------------------------------------------------------------
      function term_p_sb1(z)
      implicit none
      real*8 term_p_sb1,xb,kT,Qi,Qf,z,z1
      real*8 U1,D1,UB1,DB1,SS1,SB1,GL1
      common /vars/ xb,kT,Qi,Qf

      z1=xb/z
      call PDF_p(z1,Qi,U1,D1,UB1,DB1,SS1,SB1,GL1)
      term_p_sb1=SB1

      return
      end


c----------------------------------------------------------------
c     PDF in proton
c----------------------------------------------------------------

      subroutine PDF_p(x,Q,U,D,UB,DB,SS,SB,GL)
      implicit none
      real*8 x,Q,Q2,U,D,UB,DB,SS,SB,GL
      real*8 fUV,fDV,fUS,fDS,fSS,fSB,fGL,chm,cbar,bot,bbar,phot
c      CHARACTER prefix*100
      CHARACTER prefix*200
      integer ord
      common /iorder/ord
      INCLUDE   'TMDlibPDFpath.inc'
      INTEGER PDFPATHLEN

c     we always set PDFs at NNLO
c      write(6,*) ' PDF_p pdfpath:',pdfpath
      PDFPATHLEN=INDEX(PDFPATH,' ')-1
c      if(ord.eq.0) then       ! LL
c         prefix = "./mstw2008nnlo"
c      elseif(ord.eq.1) then   ! NLL
c         prefix = "./mstw2008nnlo"
c      elseif(ord.eq.2) then   ! NNLL
c         prefix = "./mstw2008nnlo"
c      endif
      if (ord .eq. 0) then ! LL
         prefix = PDFPATH(1:PDFPATHLEN)//'EKMP/mstw2008nnlo'
      elseif (ord .eq. 1) then ! NLL
         prefix = PDFPATH(1:PDFPATHLEN)//'EKMP/mstw2008nnlo'
      else if (ord .eq. 2) then ! NNLL
         prefix = PDFPATH(1:PDFPATHLEN)//'EKMP/mstw2008nnlo'
      end if
      call GetAllPDFs(prefix,0,x,Q,fUV,fDV,fUS,fDS,fSS,fSB,
     &     chm,cbar,bot,bbar,fGL,phot)   
      U=(fUV+fUS)/x
      D=(fDV+fDS)/x
      UB=fUS/x
      DB=fDS/x
      SS=fSS/x
      SB=fSB/x
      GL=fGL/x

      return
      end


c======================================================================
c     Integral form of the bessel functions J0(z) and J1(z)
c======================================================================
      function bessel0(z)
      IMPLICIT NONE
      REAL*8  zv,z,BESSEL0,qgauss,funb,pi
      common /zzz/ zv
      data pi /3.14159265359d0/
      external funb

      zv = z
      bessel0=qgauss(funb,0.d0,pi,4)/pi
      return
      end

c-------------------------------------------------------------------
      function bessel1(z)
      IMPLICIT NONE
      REAL*8  zv,z,BESSEL1,qgauss,funb1,pi
      common /zzz/ zv
      data pi /3.14159265359d0/
      external funb1

      zv = z
      bessel1=qgauss(funb1,0.d0,pi,4)/pi

      return
      end

c-------------------------------------------------------------------
      function funb(theta)
      implicit none
      real*8 funb,zv,theta
      common/zzz/ zv
      funb=dcos(zv*dsin(theta))
      return
      end

c-------------------------------------------------------------------
      function funb1(theta)
      implicit none
      real*8 funb1,zv,theta
      common/zzz/ zv
      funb1=dcos(zv*dsin(theta)-theta)

      return
      end
