#include "tmdlib/TMDlib.h"

using namespace TMDlib;

int nActiveSets = 0 ;
std::map<int, int> ActiveSet;
int iSet ;

TMD::TMD(void) {
    // std::cout << "TMD object is being created "  << std::endl;
}

extern "C" {
    TMD TMDlibF[200];

//  void tmdinit_(const std::string name) {
//    TMDlibF.TMDinit(name) ;
//  };
    void tmdinit_(int & isetInput) {
        int irep;
        int isetBase;
        nActiveSets = nActiveSets + 1;
        if ( isetInput >= 200000 && isetInput <= 510000 ) { irep = 0; isetBase = isetInput; }
        else if (isetInput == 101000 ) { irep = 0; isetBase = isetInput;  }
        else if (isetInput >= 101201 && isetInput <= 101999  ) { irep = 0; isetBase = isetInput;  }
        else if (isetInput >= 101010 && isetInput <= 101012  ) { irep = fmod(isetInput, 10); isetBase = isetInput - irep ; }
        else if (isetInput >= 101020 && isetInput <= 101022  ) { irep = fmod(isetInput, 10); isetBase = isetInput - irep ; }
        else if (isetInput == 101013 || isetInput == 101023  ) { irep = 0; isetBase = isetInput;  }
        else if (isetInput == 102139 || isetInput == 102239  ) { irep = 0; isetBase = isetInput;  }
        else if (isetInput >= 102140 && isetInput <= 102141  ) { irep = fmod(isetInput, 10)+1; isetBase = isetInput - irep  ;  }
        else if (isetInput >= 102240 && isetInput <= 102241  ) { irep = fmod(isetInput, 10)+1; isetBase = isetInput - irep  ;  }
        else if (isetInput == 10901300 || isetInput == 10901400) { irep = 0; isetBase = isetInput;  }
        else {
            irep = fmod(isetInput, 100);
            // std::cout << " tmdinit_ " << isetInput << " " << irep << std::endl;
            isetBase = isetInput - irep ;
        }
        int index =  nActiveSets;
        std::string name = TMDlibF[index].TMDstringPDF(isetBase) ;
        /*
        std::cout << " fortran tmdinit " << isetInput << " " << isetBase<< " name = " << name << std::endl;
        std::cout << " fortran tmdinit: irep = " << irep << std::endl;
        std::cout << " fortran tmdinit: isetBase = " << isetBase << std::endl;
        std::cout << " fortran tmdinit: nActiveSets = " << nActiveSets << " index = " << index << std::endl;
        */
        if (irep == 0 ) {TMDlibF[index].TMDinit(name) ;}
        else {TMDlibF[index].TMDinit(name, irep) ;}
        // std::cout << " before TMDgetDesc " << std::endl;
        //std::cout << "TMDSet Description: " << TMDlibF[index].TMDgetDesc() << std::endl;
        //std::cout << "TMDSet Index: " << TMDlibF[index].TMDnumberPDF(name) << std::endl;
        //std::cout << "TMDSet Extrapolation Q2: " << TMDlibF[index].TMDgetExtrapolation_Q2() << std::endl;
        ActiveSet[isetInput] = index ;
        iSet = index ;
    };

    void tmdset_(int & isetInput) {
        //std::cout << " tmdset: isetInput " << isetInput << std::endl;
        std::map<int,int>::iterator it;
        it = ActiveSet.find(isetInput);
        if (it != ActiveSet.end()) {
            iSet = ActiveSet.find(isetInput)->second ;
            // std::cout << " TMDset find: " << ActiveSet.find(isetInput)->second << " iSet = " << iSet<< std::endl;
        }
        else {
            std::cout << " TMDset find: no valid set found for isetInput = " << isetInput << std::endl;
            exit (EXIT_FAILURE); ;
        }
    };
    void tmdinfo_(char *name) {
        TMDlibF[iSet].TMDinfo(name);
        return ;
    }

    void tmdgetdesc_() {
        std::cout <<  TMDlibF[iSet].TMDgetDesc()  << std::endl;
        // TMDlibF[iSet].TMDgetDesc();
        return ;
    }

    void tmdgetindex_() {
        std::cout <<  TMDlibF[iSet].TMDgetIndex()  << std::endl;
        // TMDlibF[iSet].TMDgetIndex();
        return ;
    }

    void tmdgetscheme_() {
        std::cout <<  TMDlibF[iSet].TMDgetScheme()  << std::endl;
        // TMDlibF[iSet].TMDgetScheme();
        return ;
    }

    void tmdgetextrapolation_q2_() {
        std::cout << " TMDSet Extrapolation Q2: " << TMDlibF[iSet].TMDgetExtrapolation_Q2()  << std::endl;
        // TMDlibF[iSet].TMDgetExtrapolation_Q2();
        return ;
    }
    void tmdgetextrapolation_kt_() {
        std::cout << " TMDSet Extrapolation kt: "<<  TMDlibF[iSet].TMDgetExtrapolation_kt()  << std::endl;
        // TMDlibF[iSet].TMDgetExtrapolation_kt();
        return ;
    }
    void tmdgetextrapolation_x_() {
        std::cout << " TMDSet Extrapolation x: " <<  TMDlibF[iSet].TMDgetExtrapolation_x()  << std::endl;
        //TMDlibF[iSet].TMDgetExtrapolation_x();
        return ;
    }

    double tmdalphas_(double & mu) {
        double ret_val = TMDlibF[iSet].TMDalphas(mu);
        //std::cout << "tmdalphas = " << ret_val<< std::endl;
        return ret_val;
    }

    int tmdgetorderalphas_() {
        int ret_val = TMDlibF[iSet].TMDgetOrderAlphaS();
        //std::cout << " tmdgetorderalphas_ " << ret_val<< std::endl;
        return ret_val;
    }

    double tmdgetlam4_() {
        double ret_val= TMDlibF[iSet].TMDgetLam4();
        return ret_val;
    }

    int tmdgetorderpdf_() {
        int ret_val = TMDlibF[iSet].TMDgetOrderPDF();
        return ret_val;
    }

    double tmdgetxmin_() {

        double ret_val = TMDlibF[iSet].TMDgetXmin();
        return ret_val;
    }

    double tmdgetxmax_() {
        double ret_val = TMDlibF[iSet].TMDgetXmax();
        return ret_val;
    }

    double tmdgetq2min_() {
        double ret_val = TMDlibF[iSet].TMDgetQ2min();
        return ret_val;
    }

    double tmdgetqmin_() {
        double ret_val = TMDlibF[iSet].TMDgetQmin();
        return ret_val;
    }

    double tmdgetq2max_() {
        double ret_val = TMDlibF[iSet].TMDgetQ2max();
        return ret_val;
    }

    double tmdgetqmax_() {
        double ret_val = TMDlibF[iSet].TMDgetQmax();
        return ret_val;
    }

    int tmdgetnf_() {
        int ret_val = TMDlibF[iSet].TMDgetNf();
        return ret_val;
    }

    int tmdnumberpdf_(char *name) {
        int ret_val = TMDlibF[iSet].TMDnumberPDF(name);
        return ret_val;
    }

    int tmdgetnummembers_(char *name) {
        int ret_val = TMDlibF[iSet].TMDgetNumMembers();
        return ret_val;
    }

    // TMDpdf
    void tmdpdf_(int &kf, double &x, double &xbar, double &kt, double &mu, double& up, double& ubar,
                 double& dn, double& dbar,double& strange, double& sbar, double& charm, double& cbar, double& bottom, double& bbar, double& gluon) {
        /*
         return the TMD pdf
        */
        double photon, z0, wplus, wminus, higgs ;
        TMDlibF[iSet].TMDpdf(x, xbar, kt, mu, up, ubar, dn, dbar, strange, sbar, charm, cbar, bottom, bbar, gluon, photon);
        // std::cout << " tmdpdf_ " << uval << " " << dval << " " << gluon << std::endl;
    }
    // TMDpdf
    void tmdpdfew_(double &x, double &xbar, double &kt, double &mu, double& up, double& ubar,
                   double& dn, double& dbar,double& strange, double& sbar, double& charm, double& cbar, double& bottom, double& bbar, double& gluon,  double& photon, double& z0, double& wplus, double& wminus, double& higgs) {
        /*
         return the TMD pdf
        */

        TMDlibF[iSet].TMDpdf(x, xbar, kt, mu, up, ubar, dn, dbar, strange, sbar, charm, cbar, bottom, bbar, gluon, photon, z0, wplus, wminus, higgs);
        // std::cout << " tmdpdf_ " << uval << " " << dval << " " << gluon << std::endl;
    }
    // TMDpdf
    void tmdpdfset_(int &isetInput, int &kf, double &x, double &xbar, double &kt, double &mu, double& up, double& ubar,
                    double& dn, double& dbar,double& strange, double& sbar, double& charm, double& cbar, double& bottom, double& bbar, double& gluon) {
        /*
         return the TMD pdf with isetInput
        */
        double photon ;

        std::map<int,int>::iterator it;
        it = ActiveSet.find(isetInput);
        if (it != ActiveSet.end()) {
            iSet = ActiveSet.find(isetInput)->second ;
            // std::cout << " tmdpdfset_ find: " << ActiveSet.find(isetInput)->second << " iSet = " << iSet<< std::endl;
        }
        else {
            std::cout << " tmdpdfset_ find: no valid set found for isetInput = " << isetInput << " EXIT_FAILURE " << std::endl;
            exit (EXIT_FAILURE); ;
        }

        TMDlibF[iSet].TMDpdf(x, xbar, kt, mu, up, ubar, dn, dbar, strange, sbar, charm, cbar, bottom, bbar, gluon, photon);
        // std::cout << " tmdpdf_ " << uval << " " << dval << " " << gluon << std::endl;
    }

    void tmdpdfset_xpq_(int &isetInput, double &x, double &xbar, double &kt, double &mu, double* xpq ) {
        /*
         return the TMD pdf as an array with isetInput
        */
        std::map<int,int>::iterator it;
        it = ActiveSet.find(isetInput);
        if (it != ActiveSet.end()) {
            iSet = ActiveSet.find(isetInput)->second ;
            // std::cout << " tmdpdfset_ find: " << ActiveSet.find(isetInput)->second << " iSet = " << iSet<< std::endl;
        }
        else {
            std::cout << " tmdpdfset_ find: no valid set found for isetInput = " << isetInput << " EXIT_FAILURE " << std::endl;
            exit (EXIT_FAILURE); ;
        }
        std::cout << " tmdpdfset_xpq " << isetInput << " " << iSet << std::endl;
        std::vector<double> arr(14);
        TMDlibF[iSet].TMDpdf( x, xbar, kt,  mu, arr) ;
        std::copy(arr.begin(),arr.begin()+14,xpq);
    }
}
