/* Cdhfint.cc -- translated from dhfint.f   */

#include "tmdlib/TMDlib.h"

#include <iostream>
#include <sstream>
#include <string>
#include <fstream>

using namespace TMDlib;


/* Revision 1.1.1.1  1996/02/15 17:48:36  mclareni */
/* Kernlib */


double TMD::Cdhfint(int narg, double arg[500], int nent[500], double ent[500], double table[1000000])
/**
* Interpolation routine,originally from CERNlib
*
*  Author: C. LETERTRE.
*
*  Modified by B. SCHORR, 1.07.1982.
*/
{
    int i1, i2, i3;
    double ret_val, d1;


    /* Local variables */
    static double h;
    static int i, k, n;
    static double x, eta;
    static int loca, locb, locc, ndim, lmin, lmax;
    static bool mflag, rflag;
    static int index[32], istep, knots, lgfile, ishift;
    static double weight[32];


    /* Parameter adjustments ala f2c*/
    --table;
    --ent;
    --nent;
    --arg;

    /* Function Body */
    ret_val = 0.;
    if (narg < 1 || narg > 5) {
        std::cout << " goto 300 " << std::endl ;
        goto L300;
    }
    lmax = 0;
    istep = 1;
    knots = 1;
    index[0] = 1;
    weight[0] = 1.;
    lgfile = 0;
    i1 = narg;
//    std::cout << " narg " << narg << std::endl;
    for (n = 1; n <= i1; ++n) {
        x = arg[n];
        ndim = nent[n];
        loca = lmax;
        lmin = lmax + 1;
        lmax += ndim;
//      std::cout << "Cdhfint: n = " << n << " lmin= " <<lmin <<" lmax= " << lmax << std::endl;
//      std::cout << "Cdhfint: x = " << x << " ndim= " <<ndim<< std::endl;
        if (ndim > 2) {
            goto L10;
        }
        if (ndim == 1) {
            goto L100;
        }
        h = x - ent[lmin];
        if (h == 0.) {
            goto L90;
        }
        ishift = istep;
        if (x - ent[lmin + 1] == 0.) {
            goto L21;
        }
        ishift = 0;
        eta = h / (ent[lmin + 1] - ent[lmin]);
        goto L30;
L10:
        locb = lmax + 1;
L11:
        locc = (loca + locb) / 2;
        if ((d1 = x - ent[locc]) < 0.) {
            goto L12;
        } else if (d1 == 0) {
            goto L20;
        } else {
            goto L13;
        }
L12:
        locb = locc;
        goto L14;
L13:
        loca = locc;
L14:
        if (locb - loca > 1) {
            goto L11;
        }
        /* Computing MIN */
        i2 = std::max(loca,lmin), i3 = lmax - 1;
        loca = std::min(i2,i3);
        ishift = (loca - lmin) * istep;
        eta = (x - ent[loca]) / (ent[loca + 1] - ent[loca]);
        goto L30;
L20:
        ishift = (locc - lmin) * istep;
L21:
        i2 = knots;
        for (k = 1; k <= i2; ++k) {
            index[k - 1] += ishift;
            /* L22: */
        }
        goto L90;
L30:
        i2 = knots;
        for (k = 1; k <= i2; ++k) {
            index[k - 1] += ishift;
            index[k + knots - 1] = index[k - 1] + istep;
            weight[k + knots - 1] = weight[k - 1] * eta;
            weight[k - 1] -= weight[k + knots - 1];
            /* L31: */
        }
        knots = 2*knots;
L90:
        istep *= ndim;
L100:
        ;
    }
    i1 = knots;
    for (k = 1; k <= i1; ++k) {
        i = index[k - 1];
        ret_val += weight[k - 1] * table[i];
        /* L200: */
    }
//    std::cout << "L200 Cdhfint: ret value " << ret_val << std::endl;
    return ret_val;
L300:
    /*          CALL KERMTR('E104.1',LGFILE,MFLAG,RFLAG) */
    std::cout << " FUNCTION CDHFINT ... NARG = " << narg << " NOT WITHIN RANGE " << std::endl;
    std::cout << "L300 Cdhfint: ret value " << ret_val << std::endl;
    return ret_val;
}

