//#define DEBUG

#include "tmdlib/TMDlib.h"

#include <iostream>
#include <sstream>
#include <string>
#include <fstream>

using namespace TMDlib;
/* Common Block Declarations */

extern std::string pdfpath;


void TMD::allFlavuPDF_old(double x, double kt, double p, double& up, double& ubar, double& dn, double& dbar, double& strange, double& sbar, double& charm, double& cbar, double& bottom, double& bbar, double& top, double& tbar, double& phot,  double& glu)
{
    /**
    * Routine to interpolate TMDgrids and to return momentum weighted TMD parton density as function of x, kt, scale p for different flavors.
    *
    * General interpolation routine for PB TMDs (as well as CCFM uPDFs).
    *
    * TMDgrid in form of 51,51,51 for logx, logkt2 and log p, for flavours [-6,..,0,... 6, 22], note id=0->id=21 gluon
    *
    * Parametrization for protons.
    *
    */
    /* Initialized data */

    static int na[3] = { 51,51,51 };



    /* Local variables */
    int irr, i, j, k, in, ip;
    int igrid;
    char txt[72], adum[1];
    double rp,rx,rq2;
    double rkms0, rkms1, rkms2, rkms3, rkms4, rkms5, rkms6, rkms7, rkms1b, rkms2b, rkms3b, rkms4b, rkms5b, rkms6b;
    double bb, ktqt, qcdlam, scal, qtd1, ktd1;
    double uval,dval;

    std::string filename;

    // cout << " in allFlavuPDF_old " << first << endl;

    /* Function Body */
    if (first) {
        n1min = 0;
        n1max = 0;
        n2min = 0;
        n2max = 0;
        n3min = 0;
        n3max = 0;
        ncall = 0;
        i = 0;
        scal = 1.;
        ipgg = 0;
        rkms0 =0;
        rkms1 =0;
        rkms2=0;
        rkms3=0;
        rkms4=0;
        rkms5=0;
        rkms6=0;
        rkms7=0;
        rkms1b=0;
        rkms2b=0;
        rkms3b=0;
        rkms4b=0;
        rkms5b=0;
        rkms6b=0;
        ns_sel = -1;
        /*      pdfpath = getenv ("TMDlibPATH");
              if (pdfpath!="") { }
                else  {pdfpath="../data/"; }
              if (pdfpath!="") { cout << "TMDlib::allFalvuPDF: TMDlibPATH = " <<  pdfpath << endl;}
                  else { cout << " NO TMDlibPATH  set " <<endl;
                  return ;}
        */
        if( iset < 0 )
        {   std::cout << "  TMDlib:allFlavuPDF_old set not foud. iset = " << iset << std::endl;
            return ;
        }
        else if ( iset == 101111 ) {
            filename=pdfpath+TMD_Dir+"ccfm-test.dat";
        }
        else if ( iset == 101112 ) {
            filename=pdfpath+TMD_Dir+"ccfm-test1.dat";
        }
        else if ( iset == 101113 ) {
            filename=pdfpath+TMD_Dir+"ccfm-test2.dat";
        }
        else if ( iset == 101114 ) {
            filename=pdfpath+TMD_Dir+"ccfm-test3.dat";
        }
        else if ( iset == 101000 ) {
            filename=pdfpath+TMD_Dir+"ccfm.dat";
        }
        else if ( iset == 101001 ) {
            filename=pdfpath+TMD_Dir+"ccfm-ipgg0ns-1-0-all-lhc.dat";
        }
        else if ( iset == 101002 ) {
            filename=pdfpath+TMD_Dir+"ccfm-ipgg1ns1-0-all-lhc.dat";
        }
        else if ( iset == 101003 ) {
            filename=pdfpath+TMD_Dir+"ccfm-ipgg2ns2-0-all-lhc.dat";
        }
        else if ( iset == 101010 ) {
            filename=pdfpath+TMD_Dir+"ccfm-final-setA0.dat";
        }
        else if ( iset == 101011 ) {
            filename=pdfpath+TMD_Dir+"ccfm-final-setA0+.dat";
        }
        else if ( iset == 101012 ) {
            filename=pdfpath+TMD_Dir+"ccfm-final-setA0-.dat";
        }
        else if ( iset == 101013 ) {
            filename=pdfpath+TMD_Dir+"ccfm-final-setA1.dat";
        }
        else if ( iset == 101020 ) {
            filename=pdfpath+TMD_Dir+"ccfm-final-setB0.dat";
        }
        else if ( iset == 101021 ) {
            filename=pdfpath+TMD_Dir+"ccfm-final-setB0+.dat";
        }
        else if ( iset == 101022 ) {
            filename=pdfpath+TMD_Dir+"ccfm-final-setB0-.dat";
        }
        else if ( iset == 101023 ) {
            filename=pdfpath+TMD_Dir+"ccfm-final-setB1.dat";
        }

        else if ( iset == 101201 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1.dat";
        }
        else if ( iset == 101202 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1-par1+.dat";
        }
        else if ( iset == 101203 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1-par1-.dat";
        }
        else if ( iset == 101204 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1-par2+.dat";
        }
        else if ( iset == 101205 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1-par2-.dat";
        }
        else if ( iset == 101206 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1-par3+.dat";
        }
        else if ( iset == 101207 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1-par3-.dat";
        }
        else if ( iset == 101208 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1-muf+.dat";
        }
        else if ( iset == 101209 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1-muf-.dat";
        }
        else if ( iset == 101210 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1-mur+.dat";
        }
        else if ( iset == 101211 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1-mur-.dat";
        }
        else if ( iset == 101212 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1-Q0-.dat";
        }
        else if ( iset == 101213 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set1-Q0+.dat";
        }
        else if ( iset == 101301 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2.dat";
        }
        else if ( iset == 101302 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2-par1+.dat";
        }
        else if ( iset == 101303 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2-par1-.dat";
        }
        else if ( iset == 101304 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2-par2+.dat";
        }
        else if ( iset == 101305 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2-par2-.dat";
        }
        else if ( iset == 101306 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2-par3+.dat";
        }
        else if ( iset == 101307 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2-par3-.dat";
        }
        else if ( iset == 101308 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2-muf+.dat";
        }
        else if ( iset == 101309 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2-muf-.dat";
        }
        else if ( iset == 101310 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2-mur+.dat";
        }
        else if ( iset == 101311 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2-mur-.dat";
        }
        else if ( iset == 101312 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2-Q0-.dat";
        }
        else if ( iset == 101313 ) {
            filename=pdfpath+TMD_Dir+"JH-2013-set2-Q0+.dat";
        }

        else if ( iset == 101800 ) {filename=pdfpath+TMD_Dir+"PB-TMDLO-HERAI+II-2018-asq.dat";}
        else if ( iset == 101900 ) {filename=pdfpath+TMD_Dir+"PB-TMDLO-HERAI+II-2018-aspt.dat";}

        else if ( iset == 102100 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq.dat";}
        else if ( iset == 102101 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s01m.dat";}
        else if ( iset == 102102 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s01p.dat";}
        else if ( iset == 102103 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s02m.dat";}
        else if ( iset == 102104 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s02p.dat";}
        else if ( iset == 102105 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s03m.dat";}
        else if ( iset == 102106 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s03p.dat";}
        else if ( iset == 102107 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s04m.dat";}
        else if ( iset == 102108 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s04p.dat";}
        else if ( iset == 102109 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s05m.dat";}
        else if ( iset == 102110 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s05p.dat";}
        else if ( iset == 102111 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s06m.dat";}
        else if ( iset == 102112 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s06p.dat";}
        else if ( iset == 102113 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s07m.dat";}
        else if ( iset == 102114 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s07p.dat";}
        else if ( iset == 102115 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s08m.dat";}
        else if ( iset == 102116 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s08p.dat";}
        else if ( iset == 102117 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s09m.dat";}
        else if ( iset == 102118 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s09p.dat";}
        else if ( iset == 102119 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s10m.dat";}
        else if ( iset == 102120 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s10p.dat";}
        else if ( iset == 102121 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s11m.dat";}
        else if ( iset == 102122 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s11p.dat";}
        else if ( iset == 102123 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s12m.dat";}
        else if ( iset == 102124 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s12p.dat";}
        else if ( iset == 102125 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s13m.dat";}
        else if ( iset == 102126 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s13p.dat";}
        else if ( iset == 102127 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s14m.dat";}
        else if ( iset == 102128 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-s14p.dat";}
        else if ( iset == 102129 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-m15m.dat";}
        else if ( iset == 102130 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-m15p.dat";}
        else if ( iset == 102131 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-m16m.dat";}
        else if ( iset == 102132 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-m16p.dat";}
        else if ( iset == 102133 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-m17m.dat";}
        else if ( iset == 102134 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-m17p.dat";}
        else if ( iset == 102139 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq.dat";}
        else if ( iset == 102140 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-q0m.dat";}
        else if ( iset == 102141 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-asq-q0p.dat";}

        else if ( iset == 102200 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt.dat";}
        else if ( iset == 102201 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s01m.dat";}
        else if ( iset == 102202 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s01p.dat";}
        else if ( iset == 102203 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s02m.dat";}
        else if ( iset == 102204 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s02p.dat";}
        else if ( iset == 102205 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s03m.dat";}
        else if ( iset == 102206 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s03p.dat";}
        else if ( iset == 102207 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s04m.dat";}
        else if ( iset == 102208 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s04p.dat";}
        else if ( iset == 102209 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s05m.dat";}
        else if ( iset == 102210 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s05p.dat";}
        else if ( iset == 102211 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s06m.dat";}
        else if ( iset == 102212 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s06p.dat";}
        else if ( iset == 102213 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s07m.dat";}
        else if ( iset == 102214 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s07p.dat";}
        else if ( iset == 102215 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s08m.dat";}
        else if ( iset == 102216 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s08p.dat";}
        else if ( iset == 102217 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s09m.dat";}
        else if ( iset == 102218 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s09p.dat";}
        else if ( iset == 102219 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s10m.dat";}
        else if ( iset == 102220 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s10p.dat";}
        else if ( iset == 102221 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s11m.dat";}
        else if ( iset == 102222 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s11p.dat";}
        else if ( iset == 102223 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s12m.dat";}
        else if ( iset == 102224 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s12p.dat";}
        else if ( iset == 102225 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s13m.dat";}
        else if ( iset == 102226 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s13p.dat";}
        else if ( iset == 102227 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s14m.dat";}
        else if ( iset == 102228 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-s14p.dat";}
        else if ( iset == 102229 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-m15m.dat";}
        else if ( iset == 102230 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-m15p.dat";}
        else if ( iset == 102231 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-m16m.dat";}
        else if ( iset == 102232 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-m16p.dat";}
        else if ( iset == 102233 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-m17m.dat";}
        else if ( iset == 102234 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-m17p.dat";}
        else if ( iset == 102235 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-m18m.dat";}
        else if ( iset == 102236 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-m18p.dat";}
        else if ( iset == 102239 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt.dat";}
        else if ( iset == 102240 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-q0m.dat";}
        else if ( iset == 102241 ) {filename=pdfpath+TMD_Dir+"PB-TMDNLO-HERAI+II-2018-aspt-q0p.dat";}
        else if ( iset == 800001 ) {filename=pdfpath+"MCdir/updfgrid-pythia8210-14TeV-strictscale-oldx2-CT10nlo-CUETP8S1-primkt-IPS-noFPS-noMPI.dat";}
        else if ( iset == 800002 ) {filename=pdfpath+"MCdir/updfgrid-pythia8210-14TeV-strictscale-oldx2-CT10nlo-CUETP8M1-primkt-IPS-noFPS-noMPI.dat";}

        std::string text1,text2,text3,text4,textdum;
        const char *testname = filename.c_str();
#ifdef DEBUG
        std::cout <<  "allFlavuPDF_old: read grid from " << filename << std::endl;
        std::cout << testname << std::endl;
#endif
        std::ifstream myfile (testname);
        if (myfile.is_open()) {
            myfile >> text1 >> textdum >> qg0 >> text2 >>  ikincut ;
            // cout << " 1st read " << endl;
#ifdef DEBUG
            std::cout << text1 << " " << qg0 << " "<< text2 << " " << ikincut <<std::endl;
#endif
            if( iset != 101000) {
                myfile >> text1 >> textdum >> ipgg >> text2 >> textdum >> ns_sel ;
                // cout << " 2nd read " << endl;
#ifdef DEBUG
                std::cout << text1 << " " << ipgg << " "<< text2 << " " << ns_sel <<std::endl;
#endif
            }
            if ( iset >= 101000 && iset <= 101003 ) { //cout << " 101000 - 101003 read nothing " << endl;
            }
            else if ( iset >= 101010 && iset < 101023 ) {
                myfile >> text1 >> textdum >> textdum >> textdum >> textdum>> textdum ;
                // cout << " 101010 - 101023 read 3 " << endl;
#ifdef DEBUG
                std::cout << text1 << " "  <<  textdum << " " << textdum << std::endl;
#endif
            }
            else if ( iset >= 101200 && iset < 101320 ) {
                myfile >> text1 >> textdum >> qcdlam  ;
                //cout << " 101200 - 101320 read 3 qdclam " << endl;
            }
            else if ( iset >= 101111 && iset <= 101119 ) {
                myfile >> text1 >> textdum >> qcdlam  ;
                // cout << " 101111 - 101119 read 3 qdclam " << endl;
            }
            else if ( iset >= 101500 && iset <= 109999 ) {
                myfile >> text1 >> textdum >> qcdlam  ;
                //cout << " 101500 - 109999 read 3 qdclam " << endl;
            }
            else if ( iset >= 800001 && iset <= 800010 ) {
                myfile >> text1 >> textdum >> qcdlam  ;
                //cout << " 800001 - 800010 read 3 qdclam " << endl;
            }
            else if ( iset >= 10000000 && iset <= 19000000 ) {
                myfile >> text1 >> textdum >> qcdlam  ;
                //cout << " 800001 - 800010 read 3 qdclam " << endl;
            }
            else {
                myfile >> textdum >> textdum >> textdum >> textdum >> textdum >> textdum;
                // cout << " remaining read 6 " << endl;
            }

            myfile >> text1 >> text2 >> text3>> text4  ;
            //cout << " 4th read " << endl;
#ifdef DEBUG
            std::cout << text1 << text2 << text3 << text4 << std::endl;
#endif

            for (j = 1; j <= 51; ++j) {
                for (i = 1; i <= 51; ++i) {
                    for (k = 1; k <= 51; ++k) {
                        if (!myfile.eof() ) {
                            if ( iset >= 101200 && iset < 101320 ) {
                                myfile >>  rx >> rq2 >> rp >> rkms4b >>rkms3b >> rkms2b >> rkms1b
                                       >> rkms0 >> rkms1 >> rkms2 >> rkms3 >> rkms4 ;
                            }
                            else if ( iset >= 101111 && iset <= 101119 ) {
                                myfile >>  rx >> rq2 >>rp >> rkms6b >> rkms5b >> rkms4b >>rkms3b >> rkms2b >> rkms1b >> rkms0 >> rkms1 >> rkms2 >> rkms3 >> rkms4 >> rkms5>> rkms6>> rkms7;
                            }
                            else if ( iset >= 101500 && iset <= 109999 ) {
                                myfile >>  rx >> rq2 >>rp >> rkms6b >> rkms5b >> rkms4b >>rkms3b >> rkms2b >> rkms1b >> rkms0 >> rkms1 >> rkms2 >> rkms3 >> rkms4 >> rkms5>> rkms6>> rkms7;
                            }
                            else if ( iset >= 800001 && iset <= 800010 ) {
                                myfile >>  rx >> rq2 >>rp >> rkms6b >> rkms5b >> rkms4b >>rkms3b >> rkms2b >> rkms1b >> rkms0 >> rkms1 >> rkms2 >> rkms3 >> rkms4 >> rkms5>> rkms6>> rkms7;
                            }
                            else if ( iset >= 10000000 && iset <= 19000000 ) {
                                myfile >>  rx >> rq2 >>rp >> rkms6b >> rkms5b >> rkms4b >>rkms3b >> rkms2b >> rkms1b >> rkms0 >> rkms1 >> rkms2 >> rkms3 >> rkms4 >> rkms5>> rkms6>> rkms7;
                            }
                            else {
                                myfile >>  rx >> rq2 >> rp >> rkms0  ;
                            }
                            // cout << " rx " << rx << " " << rq2 << " " << rp << " rkms0 " << rkms0  << " "  << rkms1 << " " <<rkms2 << "rkms3 "<< rkms3 << " rkms4 " << rkms4 << endl;
                        }
                        if (rx != rx) rx = 0.;
                        if (rq2 != rq2) rq2 = 0.;
                        if (rp != rp) rp = 0.;
                        if (rkms0 != rkms0) rkms0=0;
                        if (rkms1 != rkms1) rkms1=0;
                        if (rkms2 != rkms2) rkms2=0;
                        if (rkms3 != rkms3) rkms3=0;
                        if (rkms4 != rkms4) rkms4=0;
                        if (rkms5 != rkms5) rkms5=0;
                        if (rkms6 != rkms6) rkms6=0;
                        if (rkms7 != rkms7) rkms7=0;
                        if (rkms1b != rkms1b) rkms1b=0;
                        if (rkms2b != rkms2b) rkms2b=0;
                        if (rkms3b != rkms3b) rkms3b=0;
                        if (rkms4b != rkms4b) rkms4b=0;
                        if (rkms5b != rkms5b) rkms5b=0;
                        if (rkms6b != rkms6b) rkms6b=0;
                        xx[i] = rx;
                        q2x[j] = rq2;
                        px[k] = rp;
                        // cout << i << " " << j <<" " << q2x[j] << " " << k << endl;
                        f_grid0[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms0) * scal;
                        f_grid1[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms1) * scal;
                        f_grid2[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms2) * scal;
                        f_grid3[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms3) * scal;
                        f_grid4[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms4) * scal;
                        f_grid5[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms5) * scal;
                        f_grid6[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms6) * scal;
                        f_grid7[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms7) * scal;
                        f_grid1m[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms1b) * scal;
                        f_grid2m[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms2b) * scal;
                        f_grid3m[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms3b) * scal;
                        f_grid4m[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms4b) * scal;
                        f_grid5m[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms5b) * scal;
                        f_grid6m[j + (i + k * 51) * 51 - 2653] = std::max(0.,rkms6b) * scal;
                        //if ( rkms0 > 0 ) cout << " fgrid  " << f_grid0[j + (i + k * 51) * 51 - 2653]<< " " << j << " " << i << " " << k << endl ;
                    }
                }
            }
            // cout << " end of file: allFlavuPDF_old at " << j << " " << i << " " << k << endl;
        }
        else {
            std::cout << " error file not found " << std::endl;
            return ;
        }
        in = 0;
        for (i = 1; i <= 51; ++i) {
            ++in;
            a[in - 1] = q2x[i];
        }
        for (i = 1; i <= 51; ++i) {
            ++in;
            a[in - 1] = xx[i];
        }
        for (i = 1; i <= 51; ++i) {
            ++in;
            a[in - 1] = px[i];
        }

        first = false;
#ifdef DEBUG
        std::cout <<  "  parton densities read from file unit 30 " << endl;
#endif
        //cout <<  " end init:  iset = " << iset << " f_grid0[500] " << f_grid0[9 + (5 + 10 * 51) * 51 - 2653] << endl;
    }
    // initialise values to zero
    glu = 0;
    up = 0;
    ubar  = 0 ;
    uval = 0 ;
    dn = 0;
    dbar = 0;
    dval = 0;
    strange = 0;
    sbar = 0;
    charm = 0;
    cbar = 0;
    bottom = 0;
    bbar = 0;
    top = 0;
    tbar = 0;
    phot = 0;


    // cout <<  " in loop:  iset = " << iset << " f_grid0[500] " << f_grid0[9 + (5 + 10 * 51) * 51 - 2653] << endl;


    ++ncall;
    q2 = kt*kt ;
    // cout << " params in allFlavuPDF_old: " <<x  << " " << kt << " " <<  p << endl;

    xa[0] = log(q2);
    xa[1] = log(x);
    xa[2] = log(p);
    // cout << " ccmfuPDF p = " << p << endl;
    //cout << " params in ccmfupf: " <<xa[0] << " " << xa[1] << " " <<  xa[2] << endl;
    //cout << " params in ccmfupf x: " << xa[1] << " limits " << xx[1] << " " << xx[51] <<  endl;
    //cout << " params in ccmfupf kt2: " << xa[0] << " limits " << q2x[1] << " " << q2x[51] <<  endl;
    //cout << " params in ccmfupf p: " << xa[2] << " limits " << px[1] << " " << px[51] <<  endl;
    if (xa[2] < px[1]) {
        ++n3min;
        if (n3min < 10) {
            std::cout <<" TMDlib:allFlavuPDF_old p out of range " << p << " min p " << std::exp(px[1]) <<std::endl;
            // cout <<" TMDlib:allFlavuPDF_old p out of range " << xa[2] << " " << px[1] << endl;
        } else if (n3min == 10) {
            std::cout << " TMDlib:allFlavuPDF_old p out of range " << p << " min p " << std::exp(px[1]) << std::endl;
            std::cout << " TMDlib:allFlavuPDF_old last message printed: min p " << std::endl;
        }
        xa[2] = px[1];
    }
    if (xa[2] > px[51]) {
        ++n3max;
        if (n3max < 10) {
            //    write(6,*) ' p out of range ',p,' max p ',exp(px(n3)) */
        } else if (n3max == 10) {
            //    write(6,*) ' p out of range ',p,' max p ',exp(px(n3)) */
            //    write(6,*) ' last message printed: max p' */
        }
        xa[2] = px[51];
    }
    if (xa[1] >= xx[51]) {
        xa[1] = xx[51] - 1e-4;
    }
    if (xa[1] < xx[1]) {
        ++n2min;
        if (n2min < 10) {
            //   write(6,*) '  x out of range ',x,' min ',exp(xx(1)) */
        } else if (n2min == 10) {
            //  write(6,*) '  x out of range ',x,' min ',exp(xx(1)) */
            //   write(6,*) ' last message printed: min x' */
        }
        xa[1] = xx[1];
    }
//    cout << " q2 " << q2 << " kt " << kt << " " << exp(q2x[1]) << endl;
    if (xa[0] < q2x[1]) {
        ++n1min;
        /*
             if (n1min < 10) {
                 cout << "  k2 out of range " << q2 << "  min " << exp(q2x[1]) << endl;
        	} else if (n1min == 10) {
                 cout << "  k2 out of range " << q2 << "  min " << exp(q2x[1]) << endl;
                 cout << " last message printed: min k2 " << endl;
        	}
        	//xa[0] = q2x[1];
              //q2 = exp(xa[0]);
        */
        //cout << "  k2 out of range " << exp(xa[0]) << "  min " << exp(q2x[1]) << endl;
        return ;
    }
    if (xa[0] >= q2x[51]) {
        ++n1max;
        /*
          if (n1max < 10) {
             cout << " k2 out of range " << q2 << "  max " << exp(q2x[51]) << endl;
        } else if (n1max == 10) {
             cout << " k2 out of range " << q2 << " max " <<exp(q2x[51])  << endl;
             cout << " last message printed: max k2 " <<endl;
        }
        */
        //cout << " k2 out of range " << q2 << " max " <<exp(q2x[51])  << endl;
        //xa[0] = q2x[51] - .1;
        return ;
        //q2 = exp(xa[0]);
    }
    //cout << " after params in ccmfupf x: " << xa[1] << " limits " << xx[1] << " " << xx[51] <<  endl;
    //cout << " after params in ccmfupf kt2: " << xa[0] << " limits " << q2x[1] << " " << q2x[51] <<  endl;
    //cout << " after params in ccmfupf p: " << xa[2] << " limits " << px[1] << " " << px[51] <<  endl;
    /* check if interpolation or grid wanted */
    igrid = 0;
    if (igrid == 1) {
        if (xa[0] < q2x[1]) {
            std::cout << "  k2 out of range " << q2 <<  " min " << exp(q2x[1]) << " " << q2x[1] <<" "<< q2x[51] << std::endl;
            xa[0] = q2x[1];
        }
        if (xa[0] >= q2x[51]) {
            std::cout<<  "  k2 out of range " << q2 <<  " max " << exp(q2x[51]) << std::endl;
            xa[0] = q2x[51] - .1;
        }
        i = 0;
L20:
        ++i;
        if (xa[0] > a[na[0] - 1]) {
            /*       write(6,*) ' q2  ',xa(1),a(na(1)) */
            std::cout << " q2 not found " << q2 << std::endl;
            i = na[0];
        } else {
            if (xa[0] >= a[i - 1] && xa[0] < a[i]) {
            } else {
                if (i <= na[0]) {
                    goto L20;
                } else {
                    std::cout <<  " at 20: q2 not found " << q2 << std::endl;
                }
            }
        }
        j = 0;
L30:
        ++j;
        if (xa[1] >= a[na[0] + j - 1] && xa[1] < a[na[0] + j]) {
        } else {
            if (j <= na[1]) {
                goto L30;
            } else {
                std::cout << " at 30: x not found " << x << std::endl;
            }
        }
        k = 0;
L40:
        ++k;
        if (xa[2] >= a[na[0] + na[1] + na[2] - 1]) {
            k = na[2];
        } else {
            if (xa[2] >= a[na[0] + na[1] + k - 1] && xa[2] < a[na[0] + na[1]
                    + k]) {
            } else {
                if (k <= na[2]) {
                    goto L40;
                } else {
                    std::cout << " at 40: p not found " << p << std::endl;
                }
            }
        }
        glu = f_grid0[i + (j + k * 51) * 51 - 2653] / q2;
        up   = f_grid2[i + (j + k * 51) * 51 - 2653] / q2;
        ubar = f_grid2m[i + (j + k * 51) * 51 - 2653] / q2;
        dn   = f_grid1[i + (j + k * 51) * 51 - 2653] / q2;
        dbar = f_grid1m[i + (j + k * 51) * 51 - 2653] / q2;
        strange = f_grid3[i + (j + k * 51) * 51 - 2653] / q2;
        sbar  = f_grid3m[i + (j + k * 51) * 51 - 2653] / q2;
        charm = f_grid4[i + (j + k * 51) * 51 - 2653] / q2;
        cbar  = f_grid4m[i + (j + k * 51) * 51 - 2653] / q2;
        bottom = f_grid5[i + (j + k * 51) * 51 - 2653] / q2;
        bbar  = f_grid5m[i + (j + k * 51) * 51 - 2653] / q2;
        top   = f_grid6[i + (j + k * 51) * 51 - 2653] / q2;
        tbar  = f_grid6m[i + (j + k * 51) * 51 - 2653] / q2;
        phot  = f_grid7[i + (j + k * 51) * 51 - 2653] / q2;
        // cout << " allFlavuPDF_old i j k "<< i << " " << j << " " << k << " " << glu << " " << q2 << " " << x << " " << p << endl;

    } else {
        int c3 = 3;
        // cout << " xa values  " << exp(xa[0]) << " " << exp(xa[1]) << " " << exp(xa[2]) << endl;
        glu   = Cdhfint(c3, xa, na, a, f_grid0) / q2;
        up    = Cdhfint(c3, xa, na, a, f_grid2) / q2;
        ubar  = Cdhfint(c3, xa, na, a, f_grid2m) / q2;
        uval  = up - ubar ;
        dn    = Cdhfint(c3, xa, na, a, f_grid1) / q2;
        dbar  = Cdhfint(c3, xa, na, a, f_grid1m) / q2;
        dval  = dn - dbar ;

        strange= Cdhfint(c3, xa, na, a, f_grid3) / q2;
        sbar   = Cdhfint(c3, xa, na, a, f_grid3m) / q2;
        charm  = Cdhfint(c3, xa, na, a, f_grid4) / q2;
        cbar   = Cdhfint(c3, xa, na, a, f_grid4m) / q2;
        bottom  = Cdhfint(c3, xa, na, a, f_grid5) / q2;
        bbar    = Cdhfint(c3, xa, na, a, f_grid5m) / q2;
        top     = Cdhfint(c3, xa, na, a, f_grid6) / q2;
        tbar    = Cdhfint(c3, xa, na, a, f_grid6m) / q2;
        phot    = Cdhfint(c3, xa, na, a, f_grid7) / q2;

    }

    // cout << " allFlavuPDF_old: iset = " << iset << " gluon " << glu<< endl;


    //cout << " allFlavuPDF_old: charm " << charm << " " << cbar << " " << q2 << endl;
    // cout << " allFlavuPDF_old: gluon = " << glu << " " << q2 << endl;
    if(up == 0 || ubar == 0) {
        //cout << " allFlavuPDF_old: up= " << up << " ubar= "<< ubar << " " << x << " " << q2 << " " << p << endl;
        //cout << " allFlavuPDF_old: dn= " << dn << " dbar= "<< dbar << " " << x << " " << q2 << " " << p << endl;
    }
    //cout << " allFlavuPDF_old x,q2,p,xpq " << x<< " " << q2 << " " << p << " "<< glu<< endl;
    if (glu > 1e6) {
        std::cout << " allFlavuPDF_old x,q2,p,xpq" << x<< " " << q2 << " " << p << " "<< glu<< std::endl;
        std::cout << " i,j,k " << i << " " << j << " " << k << std::endl;
    }
    return ;
}

