#include "tmdlib/TMDlib.h"

#include <iostream>
#include <sstream>
#include <string>
#include <fstream>
#include <math.h>

using namespace TMDlib;
/* Common Block Declarations */

extern int iset ;
extern bool first;

void TMD::gbwuPDFlight(double x, double kt, double& gluon )
{
    /* Initialized data */
    static int icharm = 0;


    /* Function Body */
    /*
    if (first) {

    cout <<  "gbwuPDF with light quarks without evolution " << endl;
      first = false ;
    }
    */
    double scale, sigm0, lam, x0, alphas, r02, glu ;
    scale = kt*kt ;
    /* mb -> 1/GeV^2 = 1/0.389379 = 2.568 */
    if ( icharm == 0 ) {
        sigm0 = 23.03*2.568 ; /*  w/o charm */
        lam  = 0.288 ;            /*  w/o charm */
        x0 =  3.04/10000. ;       /*  w/o charm */
    } else {
        sigm0 = 29.12*2.568 ; /* with charm */
        lam = 0.277 ;           /* with charm */
        x0 = 0.41/10000. ;     /* with charm */
    }
    alphas = 0.2;
    r02 = pow((x/x0),lam) ;
    glu = 3.*sigm0*r02*scale*exp(-r02*scale);
    /* pi**2 = 9.8696 */
    gluon = glu/4./9.8696/alphas;

    return ;
}

void TMD::gbwuPDFcharm(double x, double kt, double& gluon )
{
    /* Initialized data */
    static bool first = true;
    static int icharm = 1;


    /* Function Body */
    /*

    if (first) {

    cout <<  "gbwuPDF with charm quarks without evolution " << endl;
      first = false ;
    }
    */

    double scale, sigm0, lam, x0, alphas, r02, glu ;
    scale = kt*kt ;
    /* mb -> 1/GeV^2 = 1/0.389379 = 2.568 */
    if ( icharm == 0 ) {
        sigm0 = 23.03*2.568 ; /*  w/o charm */
        lam  = 0.288 ;            /*  w/o charm */
        x0 =  3.04/10000. ;       /*  w/o charm */
    } else {
        sigm0 = 29.12*2.568 ; /* with charm */
        lam = 0.277 ;           /* with charm */
        x0 = 0.41/10000. ;     /* with charm */
    }
    alphas = 0.2;
    r02 = pow((x/x0),lam) ;
    glu = 3.*sigm0*r02*scale*exp(-r02*scale);
    /* pi**2 = 9.8696 */
    gluon = glu/4./9.8696/alphas;

    return ;
}

