#include "tmdlib/TMDlib.h"

#include <iostream>
#include <sstream>
#include <string>
#include <fstream>
#include "tmdlib/TMDlib_UnintegratedGluonKS.h"
#include "tmdlib/TMDlib_InterpolationKS.h"

using namespace TMDlib;

/* Common Block Declarations */

extern int iset, irep, imode ;
extern std::string pdfpath;
extern bool first;
UnintegratedGluon *_updfg, *_updfu, *_updfub, *_updfd, *_updfdb, *_updfs,*_updfsb,*_updfc,*_updfcb,*_updfb,*_updfbb ;

std::string filename_g,filename_u,filename_ub,filename_d,filename_db,filename_s,filename_sb,filename_c,filename_cb,filename_b,filename_bb;

void TMD::ksBHKSPDF(double x, double kt, double p, double& up, double& ubar, double& down, double& dbar, double& strange, double& sbar, double& charm, double& cbar, double& bottom, double& bbar, double& glu)
{

    gsl_interp_type int_type =  *gsl_interp_cspline;
    // cout << " ksBHKSPDF " << first << endl;

    if (first) {

        if( iset < 0 )
        {   cout << "  TMDlib:ksBHKSPDF set not foud. iset = " << iset << endl;
            return ;
        }
        else if ( iset == 410001 ) {
            filename_g=pdfpath+"BHKS/MRW-CT10nlo/CT10nlo_der_gluon.dat";
            filename_u=pdfpath+"BHKS/MRW-CT10nlo/CT10nlo_der_u.dat";
            filename_ub=pdfpath+"BHKS/MRW-CT10nlo/CT10nlo_der_ubar.dat";
            filename_d=pdfpath+"BHKS/MRW-CT10nlo/CT10nlo_der_d.dat";
            filename_db=pdfpath+"BHKS/MRW-CT10nlo/CT10nlo_der_dbar.dat";
            filename_s=pdfpath+"BHKS/MRW-CT10nlo/CT10nlo_der_s.dat";
            filename_sb=pdfpath+"BHKS/MRW-CT10nlo/CT10nlo_der_sbar.dat";
            filename_c=pdfpath+"BHKS/MRW-CT10nlo/CT10nlo_der_c.dat";
            filename_cb=pdfpath+"BHKS/MRW-CT10nlo/CT10nlo_der_cbar.dat";
            filename_b=pdfpath+"BHKS/MRW-CT10nlo/CT10nlo_der_b.dat";
            filename_bb=pdfpath+"BHKS/MRW-CT10nlo/CT10nlo_der_bbar.dat";
        }
        /*
        // this was for testing
                else if ( iset == 410000 ) {
                    filename_g=pdfpath+"BHKS/MRW-int-v2/CT10nlo_int_gluon.dat";
                    filename_u=pdfpath+"BHKS/MRW-int-v2/CT10nlo_int_u.dat";
                    filename_ub=pdfpath+"BHKS/MRW-int-v2/CT10nlo_int_ubar.dat";
                    filename_d=pdfpath+"BHKS/MRW-int-v2/CT10nlo_int_d.dat";
                    filename_db=pdfpath+"BHKS/MRW-int-v2/CT10nlo_int_dbar.dat";
                    filename_s=pdfpath+"BHKS/MRW-int-v2/CT10nlo_int_s.dat";
                    filename_sb=pdfpath+"BHKS/MRW-int-v2/CT10nlo_int_sbar.dat";
                    filename_c=pdfpath+"BHKS/MRW-int-v2/CT10nlo_int_c.dat";
                    filename_cb=pdfpath+"BHKS/MRW-int-v2/CT10nlo_int_cbar.dat";
                    filename_b=pdfpath+"BHKS/MRW-int-v2/CT10nlo_int_b.dat";
                    filename_bb=pdfpath+"BHKS/MRW-int-v2/CT10nlo_int_bbar.dat";}
                else if ( iset == 410001 ) {
                    filename_g=pdfpath+"BHKS/MRW_SS-int-v2/CT10nlo_int_s_gluon.dat";
                    filename_u=pdfpath+"BHKS/MRW_SS-int-v2/CT10nlo_int_s_u.dat";
                    filename_ub=pdfpath+"BHKS/MRW_SS-int-v2/CT10nlo_int_s_ubar.dat";
                    filename_d=pdfpath+"BHKS/MRW_SS-int-v2/CT10nlo_int_s_d.dat";
                    filename_db=pdfpath+"BHKS/MRW_SS-int-v2/CT10nlo_int_s_dbar.dat";
                    filename_s=pdfpath+"BHKS/MRW_SS-int-v2/CT10nlo_int_s_s.dat";
                    filename_sb=pdfpath+"BHKS/MRW_SS-int-v2/CT10nlo_int_s_sbar.dat";
                    filename_c=pdfpath+"BHKS/MRW_SS-int-v2/CT10nlo_int_s_c.dat";
                    filename_cb=pdfpath+"BHKS/MRW_SS-int-v2/CT10nlo_int_s_cbar.dat";
                    filename_b=pdfpath+"BHKS/MRW_SS-int-v2/CT10nlo_int_s_b.dat";
                    filename_bb=pdfpath+"BHKS/MRW_SS-int-v2/CT10nlo_int_s_bbar.dat";}
                else if ( iset == 410002 ) {
                    filename_g=pdfpath+"BHKS/MRW_SS-der-v2/CT10nlo_der_s_gluon.dat";
                    filename_u=pdfpath+"BHKS/MRW_SS-der-v2/CT10nlo_der_s_u.dat";
                    filename_ub=pdfpath+"BHKS/MRW_SS-der-v2/CT10nlo_der_s_ubar.dat";
                    filename_d=pdfpath+"BHKS/MRW_SS-der-v2/CT10nlo_der_s_d.dat";
                    filename_db=pdfpath+"BHKS/MRW_SS-der-v2/CT10nlo_der_s_dbar.dat";
                    filename_s=pdfpath+"BHKS/MRW_SS-der-v2/CT10nlo_der_s_s.dat";
                    filename_sb=pdfpath+"BHKS/MRW_SS-der-v2/CT10nlo_der_s_sbar.dat";
                    filename_c=pdfpath+"BHKS/MRW_SS-der-v2/CT10nlo_der_s_c.dat";
                    filename_cb=pdfpath+"BHKS/MRW_SS-der-v2/CT10nlo_der_s_cbar.dat";
                    filename_b=pdfpath+"BHKS/MRW_SS-der-v2/CT10nlo_der_s_b.dat";
                    filename_bb=pdfpath+"BHKS/MRW_SS-der-v2/CT10nlo_der_s_bbar.dat";}
                else if ( iset == 410003 ) {
                    filename_g=pdfpath+"BHKS/MRW_der_s0/CT10nlo_der_s0_gluon.dat";
                    filename_u=pdfpath+"BHKS/MRW_der_s0/CT10nlo_der_s0_u.dat";
                    filename_ub=pdfpath+"BHKS/MRW_der_s0/CT10nlo_der_s0_ubar.dat";
                    filename_d=pdfpath+"BHKS/MRW_der_s0/CT10nlo_der_s0_d.dat";
                    filename_db=pdfpath+"BHKS/MRW_der_s0/CT10nlo_der_s0_dbar.dat";
                    filename_s=pdfpath+"BHKS/MRW_der_s0/CT10nlo_der_s0_s.dat";
                    filename_sb=pdfpath+"BHKS/MRW_der_s0/CT10nlo_der_s0_sbar.dat";
                    filename_c=pdfpath+"BHKS/MRW_der_s0/CT10nlo_der_s0_c.dat";
                    filename_cb=pdfpath+"BHKS/MRW_der_s0/CT10nlo_der_s0_cbar.dat";
                    filename_b=pdfpath+"BHKS/MRW_der_s0/CT10nlo_der_s0_b.dat";
                    filename_bb=pdfpath+"BHKS/MRW_der_s0/CT10nlo_der_s0_bbar.dat";}
                else if ( iset == 410004 ) {
                    filename_g=pdfpath+"BHKS/MRW-der-v1/CT10nlo_gluon_der.dat";
                    filename_u=pdfpath+"BHKS/MRW-der-v1/CT10nlo_u_der.dat";
                    filename_ub=pdfpath+"BHKS/MRW-der-v1/CT10nlo_ubar_der.dat";
                    filename_d=pdfpath+"BHKS/MRW-der-v1/CT10nlo_d_der.dat";
                    filename_db=pdfpath+"BHKS/MRW-der-v1/CT10nlo_dbar_der.dat";
                    filename_s=pdfpath+"BHKS/MRW-der-v1/CT10nlo_s_der.dat";
                    filename_sb=pdfpath+"BHKS/MRW-der-v1/CT10nlo_sbar_der.dat";
                    filename_c=pdfpath+"BHKS/MRW-der-v1/CT10nlo_c_der.dat";
                    filename_cb=pdfpath+"BHKS/MRW-der-v1/CT10nlo_cbar_der.dat";
                    filename_b=pdfpath+"BHKS/MRW-der-v1/CT10nlo_b_der.dat";
                    filename_bb=pdfpath+"BHKS/MRW-der-v1/CT10nlo_bbar_der.dat";}
                else if ( iset == 410005 ) {
                    filename_g=pdfpath+"BHKS/KMRi/CT10nlo_KMRi_gluon.dat";
                    filename_u=pdfpath+"BHKS/KMRi/CT10nlo_KMRi_u.dat";
                    filename_ub=pdfpath+"BHKS/KMRi/CT10nlo_KMRi_ubar.dat";
                    filename_d=pdfpath+"BHKS/KMRi/CT10nlo_KMRi_d.dat";
                    filename_db=pdfpath+"BHKS/KMRi/CT10nlo_KMRi_dbar.dat";
                    filename_s=pdfpath+"BHKS/KMRi/CT10nlo_KMRi_s.dat";
                    filename_sb=pdfpath+"BHKS/KMRi/CT10nlo_KMRi_sbar.dat";
                    filename_c=pdfpath+"BHKS/KMRi/CT10nlo_KMRi_c.dat";
                    filename_cb=pdfpath+"BHKS/KMRi/CT10nlo_KMRi_cbar.dat";
                    filename_b=pdfpath+"BHKS/KMRi/CT10nlo_KMRi_b.dat";
                    filename_bb=pdfpath+"BHKS/KMRi/CT10nlo_KMRi_bbar.dat";}
                 else if ( iset == 410006 ) {
                    filename_g=pdfpath+"BHKS/Grids_MRWd/CT10nlo_der0_gluon.dat";
                    filename_u=pdfpath+"BHKS/Grids_MRWd/CT10nlo_der0_u.dat";
                    filename_ub=pdfpath+"BHKS/Grids_MRWd/CT10nlo_der0_ubar.dat";
                    filename_d=pdfpath+"BHKS/Grids_MRWd/CT10nlo_der0_d.dat";
                    filename_db=pdfpath+"BHKS/Grids_MRWd/CT10nlo_der0_dbar.dat";
                    filename_s=pdfpath+"BHKS/Grids_MRWd/CT10nlo_der0_s.dat";
                    filename_sb=pdfpath+"BHKS/Grids_MRWd/CT10nlo_der0_sbar.dat";
                    filename_c=pdfpath+"BHKS/Grids_MRWd/CT10nlo_der0_c.dat";
                    filename_cb=pdfpath+"BHKS/Grids_MRWd/CT10nlo_der0_cbar.dat";
                    filename_b=pdfpath+"BHKS/Grids_MRWd/CT10nlo_der0_b.dat";
                    filename_bb=pdfpath+"BHKS/Grids_MRWd/CT10nlo_der0_bbar.dat";}
                else if ( iset == 410007 ) {
                    filename_g=pdfpath+"BHKS/MRW-der-v3/CT10nlo_der_gluon.dat";
                    filename_u=pdfpath+"BHKS/MRW-der-v3/CT10nlo_der_u.dat";
                    filename_ub=pdfpath+"BHKS/MRW-der-v3/CT10nlo_der_ubar.dat";
                    filename_d=pdfpath+"BHKS/MRW-der-v3/CT10nlo_der_d.dat";
                    filename_db=pdfpath+"BHKS/MRW-der-v3/CT10nlo_der_dbar.dat";
                    filename_s=pdfpath+"BHKS/MRW-der-v3/CT10nlo_der_s.dat";
                    filename_sb=pdfpath+"BHKS/MRW-der-v3/CT10nlo_der_sbar.dat";
                    filename_c=pdfpath+"BHKS/MRW-der-v3/CT10nlo_der_c.dat";
                    filename_cb=pdfpath+"BHKS/MRW-der-v3/CT10nlo_der_cbar.dat";
                    filename_b=pdfpath+"BHKS/MRW-der-v3/CT10nlo_der_b.dat";
                    filename_bb=pdfpath+"BHKS/MRW-der-v3/CT10nlo_der_bbar.dat";}
                else if ( iset == 410008 ) {
                    filename_g=pdfpath+"BHKS/MRW-v3/CT10nlo_der+fr_gluon.dat";
                    filename_u=pdfpath+"BHKS/MRW-v3/CT10nlo_der+fr_u.dat";
                    filename_ub=pdfpath+"BHKS/MRW-v3/CT10nlo_der+fr_ubar.dat";
                    filename_d=pdfpath+"BHKS/MRW-v3/CT10nlo_der+fr_d.dat";
                    filename_db=pdfpath+"BHKS/MRW-v3/CT10nlo_der+fr_dbar.dat";
                    filename_s=pdfpath+"BHKS/MRW-v3/CT10nlo_der+fr_s.dat";
                    filename_sb=pdfpath+"BHKS/MRW-v3/CT10nlo_der+fr_sbar.dat";
                    filename_c=pdfpath+"BHKS/MRW-v3/CT10nlo_der+fr_c.dat";
                    filename_cb=pdfpath+"BHKS/MRW-v3/CT10nlo_der+fr_cbar.dat";
                    filename_b=pdfpath+"BHKS/MRW-v3/CT10nlo_der+fr_b.dat";
                    filename_bb=pdfpath+"BHKS/MRW-v3/CT10nlo_der+fr_bbar.dat";}
                else if ( iset == 410009 ) {
                    filename_g=pdfpath+"BHKS/MRW-v3/CT10nlo_der+kt_gluon.dat";
                    filename_u=pdfpath+"BHKS/MRW-v3/CT10nlo_der+kt_u.dat";
                    filename_ub=pdfpath+"BHKS/MRW-v3/CT10nlo_der+kt_ubar.dat";
                    filename_d=pdfpath+"BHKS/MRW-v3/CT10nlo_der+kt_d.dat";
                    filename_db=pdfpath+"BHKS/MRW-v3/CT10nlo_der+fr_dbar.dat";
                    filename_s=pdfpath+"BHKS/MRW-v3/CT10nlo_der+kt_s.dat";
                    filename_sb=pdfpath+"BHKS/MRW-v3/CT10nlo_der+kt_sbar.dat";
                    filename_c=pdfpath+"BHKS/MRW-v3/CT10nlo_der+kt_c.dat";
                    filename_cb=pdfpath+"BHKS/MRW-v3/CT10nlo_der+kt_cbar.dat";
                    filename_b=pdfpath+"BHKS/MRW-v3/CT10nlo_der+kt_b.dat";
                    filename_bb=pdfpath+"BHKS/MRW-v3/CT10nlo_der+kt_bbar.dat";}
                else if ( iset == 410010 ) {
                    filename_g=pdfpath+"BHKS/MRW-der-v3/MMHT2014nlo68cl_der_gluon.dat";
                    filename_u=pdfpath+"BHKS/MRW-der-v3/MMHT2014nlo68cl_der_u.dat";
                    filename_ub=pdfpath+"BHKS/MRW-der-v3/MMHT2014nlo68cl_der_ubar.dat";
                    filename_d=pdfpath+"BHKS/MRW-der-v3/MMHT2014nlo68cl_der_d.dat";
                    filename_db=pdfpath+"BHKS/MRW-der-v3/MMHT2014nlo68cl_der_dbar.dat";
                    filename_s=pdfpath+"BHKS/MRW-der-v3/MMHT2014nlo68cl_der_s.dat";
                    filename_sb=pdfpath+"BHKS/MRW-der-v3/MMHT2014nlo68cl_der_sbar.dat";
                    filename_c=pdfpath+"BHKS/MRW-der-v3/MMHT2014nlo68cl_der_c.dat";
                    filename_cb=pdfpath+"BHKS/MRW-der-v3/MMHT2014nlo68cl_der_cbar.dat";
                    filename_b=pdfpath+"BHKS/MRW-der-v3/MMHT2014nlo68cl_der_b.dat";
                    filename_bb=pdfpath+"BHKS/MRW-der-v3/MMHT2014nlo68cl_der_bbar.dat";}
                else if ( iset == 410099 ) {
                    filename_g=pdfpath+"BHKS/test/gluon.dat";
                    filename_u=pdfpath+"BHKS/test/u.dat";
                    filename_ub=pdfpath+"BHKS/test/ubar.dat";
                    filename_d=pdfpath+"BHKS/test/d.dat";
                    filename_db=pdfpath+"BHKS/test/dbar.dat";
                    filename_s=pdfpath+"BHKS/test/s.dat";
                    filename_sb=pdfpath+"BHKS/test/sbar.dat";
                    filename_c=pdfpath+"BHKS/test/c.dat";
                    filename_cb=pdfpath+"BHKS/test/cbar.dat";
                    filename_b=pdfpath+"BHKS/test/b.dat";
                    filename_bb=pdfpath+"BHKS/test/bbar.dat";}
        */
        else { cout << "  ksBHKSuPDF: grid not found " << iset << endl; }
        // cout <<  "ksBHKSuPDF: read grid from " << filename_g << endl;
        _updfg = new UnintegratedGluon(filename_g,int_type);
        //cout << " after init ksBHKSuPDF " << endl;
        _updfu = new UnintegratedGluon(filename_u,int_type);
        _updfub = new UnintegratedGluon(filename_ub,int_type);
        _updfd = new UnintegratedGluon(filename_d,int_type);
        _updfdb = new UnintegratedGluon(filename_db,int_type);
        _updfs = new UnintegratedGluon(filename_s,int_type);
        _updfsb = new UnintegratedGluon(filename_sb,int_type);
        _updfc = new UnintegratedGluon(filename_c,int_type);
        _updfcb = new UnintegratedGluon(filename_cb,int_type);
        _updfb = new UnintegratedGluon(filename_b,int_type);
        _updfbb = new UnintegratedGluon(filename_bb,int_type);
        first = false ;
    }


    double logx = log(x);
    glu = 1 ;
    double kt2=kt*kt;
    /// Created updf object
    //  cout << " before glu call " << endl;
    glu = _updfg->xg(logx,log(kt*kt), log(p*p)) ;
    up = _updfu->xg(logx,log(kt*kt), log(p*p)) ;
    ubar = _updfub->xg(logx,log(kt*kt), log(p*p)) ;
    down = _updfd->xg(logx,log(kt*kt), log(p*p)) ;
    dbar = _updfdb->xg(logx,log(kt*kt), log(p*p)) ;
    strange = _updfs->xg(logx,log(kt*kt), log(p*p)) ;
    sbar = _updfsb->xg(logx,log(kt*kt), log(p*p));
    charm = _updfc->xg(logx,log(kt*kt), log(p*p)) ;
    cbar = _updfcb->xg(logx,log(kt*kt), log(p*p)) ;
    bottom = _updfb->xg(logx,log(kt*kt), log(p*p)) ;
    bbar = _updfbb->xg(logx,log(kt*kt), log(p*p)) ;
    //cout << " TMDlib bhks " << logx << " " << kt << " p = " << p << endl;
    //cout << " TMDlib bhks glu = " << glu << " up " << up << " down " << down << "strange " << strange << endl;
    // cout << " TMDlib bhks glu = " << glu << "strange " << strange << "sbar " << sbar << endl;

    return ;
}
