#include "tmdlib/TMDlib.h"

#include <iostream>
#include <sstream>
#include <string>
#include <fstream>
#include "tmdlib/TMDlib_UnintegratedGluonKS.h"
#include "tmdlib/TMDlib_InterpolationKS.h"

using namespace TMDlib;

/* Common Block Declarations */

extern int iset, irep, imode ;
extern std::string pdfpath;
extern bool first;
UnintegratedGluon *_updf_ksDLCP_g, *_updf_ksDLCP_u, *_updf_ksDLCP_ub, *_updf_ksDLCP_d,*_updf_ksDLCP_db,  *_updf_ksDLCP_s, *_updf_ksDLCP_sb, *_updf_ksDLCP_c, *_updf_ksDLCP_cb,*_updf_ksDLCP_b,*_updf_ksDLCP_bb;

std::string filename_ksDLCP_g, filename_ksDLCP_u, filename_ksDLCP_ub, filename_ksDLCP_d, filename_ksDLCP_db, filename_ksDLCP_s, filename_ksDLCP_sb, filename_ksDLCP_c, filename_ksDLCP_cb, filename_ksDLCP_b, filename_ksDLCP_bb;

void TMD::ksDLCPDF(double x, double kt, double p, double& up, double& ubar, double& down, double& dbar, double& strange, double& sbar, double& charm, double& cbar, double& bottom, double& bbar, double& glu)
{

    gsl_interp_type int_type =  *gsl_interp_cspline;
    //cout << " ksDLC " << first << " " << iset <<endl;

    if (first) {

        if( iset < 0 )
        {   cout << "  TMDlib:ksuDLSPDF set not foud. iset = " << iset << endl;
            return ;
        }
        else if ( iset == 400101 ) {
            filename_ksDLCP_g=pdfpath+"gridsDLC2016/KMR_gluon.dat";
            filename_ksDLCP_u=pdfpath+"gridsDLC2016/KMR_u.dat";
            filename_ksDLCP_ub=pdfpath+"gridsDLC2016/KMR_ubar.dat";
            filename_ksDLCP_d=pdfpath+"gridsDLC2016/KMR_d.dat";
            filename_ksDLCP_db=pdfpath+"gridsDLC2016/KMR_dbar.dat" ;
            filename_ksDLCP_s=pdfpath+"gridsDLC2016/KMR_s.dat";
            filename_ksDLCP_sb=pdfpath+"gridsDLC2016/KMR_sbar.dat" ;
            filename_ksDLCP_c=pdfpath+"gridsDLC2016/KMR_c.dat" ;
            filename_ksDLCP_cb=pdfpath+"gridsDLC2016/KMR_cbar.dat" ;
            filename_ksDLCP_b=pdfpath+"gridsDLC2016/KMR_b.dat";
            filename_ksDLCP_bb=pdfpath+"gridsDLC2016/KMR_bbar.dat";
        }
        cout <<  "ksDLCuPDF: read grid from " << filename_ksDLCP_g << endl;
        _updf_ksDLCP_g = new UnintegratedGluon(filename_ksDLCP_g,int_type);
        _updf_ksDLCP_u = new UnintegratedGluon(filename_ksDLCP_u,int_type);
        _updf_ksDLCP_ub = new UnintegratedGluon(filename_ksDLCP_ub,int_type);
        _updf_ksDLCP_d = new UnintegratedGluon(filename_ksDLCP_d,int_type);
        _updf_ksDLCP_db = new UnintegratedGluon(filename_ksDLCP_db,int_type);
        _updf_ksDLCP_s = new UnintegratedGluon(filename_ksDLCP_s,int_type);
        _updf_ksDLCP_sb = new UnintegratedGluon(filename_ksDLCP_sb,int_type);
        _updf_ksDLCP_c = new UnintegratedGluon(filename_ksDLCP_c,int_type);
        _updf_ksDLCP_cb = new UnintegratedGluon(filename_ksDLCP_cb,int_type);
        _updf_ksDLCP_b = new UnintegratedGluon(filename_ksDLCP_b,int_type);
        _updf_ksDLCP_bb = new UnintegratedGluon(filename_ksDLCP_bb,int_type);
        first = false ;
    }


    double logx = log(x);
    glu = 1 ;
    /// Created updf object
    glu = _updf_ksDLCP_g->xg(logx,log(kt*kt), log(p*p)) ;
    up = _updf_ksDLCP_u->xg(logx,log(kt*kt), log(p*p)) ;
    ubar = _updf_ksDLCP_ub->xg(logx,log(kt*kt), log(p*p)) ;
    down = _updf_ksDLCP_d->xg(logx,log(kt*kt), log(p*p)) ;
    dbar = _updf_ksDLCP_db->xg(logx,log(kt*kt), log(p*p)) ;
    strange = _updf_ksDLCP_s->xg(logx,log(kt*kt), log(p*p)) ;
    sbar = _updf_ksDLCP_sb->xg(logx,log(kt*kt), log(p*p)) ;
    charm = _updf_ksDLCP_c->xg(logx,log(kt*kt), log(p*p)) ;
    cbar = _updf_ksDLCP_cb->xg(logx,log(kt*kt), log(p*p)) ;
    bottom = _updf_ksDLCP_b->xg(logx,log(kt*kt), log(p*p)) ;
    bbar = _updf_ksDLCP_bb->xg(logx,log(kt*kt), log(p*p)) ;

//       cout << " TMDlib DLC2016 " << glu << " " << up << " " << ubar << endl;
//       cout << " TMDlib DLC2016 x =  " << x << " kt = " << kt << " p = " << p << endl;

    return ;
}
