#include "tmdlib/TMDlib.h"

#include <iostream>
#include <sstream>
#include <string>
#include <fstream>
#include "tmdlib/TMDlib_UnintegratedGluonKS.h"
#include "tmdlib/TMDlib_InterpolationKS.h"

using namespace TMDlib;

/* Common Block Declarations */

extern int iset, irep, imode ;
extern std::string pdfpath;
extern bool first;
UnintegratedGluon *_updf;

std::string filename ;

void TMD::ksPDF(double x, double kt, double p, double& up, double& dn, double& sea, double& charm, double& bottom, double& glu)
{

    gsl_interp_type int_type =  *gsl_interp_cspline;
//    cout << " ksPDF " << first << endl;

    if (first) {

        if( iset < 0 )
        {   cout << "  TMDlib:ksuPDF set not foud. iset = " << iset << endl;
            return ;
        }
        else if ( iset == 400001 ) {
            filename=pdfpath+TMD_Dir+"KSlinear.dat";
        }
        else if ( iset == 400002 ) {
            filename=pdfpath+TMD_Dir+"KSnonlinear.dat";
        }
        else if ( iset == 400003 ) {
            filename=pdfpath+TMD_Dir+"KShardscalelinear.dat";
        }
        else if ( iset == 400004 ) {
            filename=pdfpath+TMD_Dir+"KShardscalenonlinear.dat";
        }
        else  {
            // filename=pdfpath+TMD_Dir+"KShardscalenonlinear.dat";
            filename=pdfpath+TMD_Dir+TMD_Name+"_"+TMD_Mem+".dat";
        }
        // cout <<  "ksuPDF: read grid from " << filename << endl;
        _updf = new UnintegratedGluon(filename,int_type);
        // cout<<  " after read " << endl;
        first = false ;
    }


    double logx = log(x);
    glu = 1 ;
    /// Created updf object
    //cout << "before updf " << endl;
    glu = _updf->xg(logx,log(kt*kt), log(p*p)) ;
    //cout << " TMDlib ks gluon = " << glu << " " << logx << " " << kt << " p = " << p << endl;
    up = 0 ;
    dn = 0 ;

    return ;
}
