#include "tmdlib/TMDlib.h"

#include <iostream>
#include <sstream>
#include <string>
#include <fstream>

using namespace TMDlib;

//Function polint, performs polynomial interpolation
//(taken from Numerical Recipes)

void TMD::polint(double xa[], double ya[], int n, double x, double& y, double& dy)
{
    int i, m, ns=0;
    double den, dif, dift, ho, hp, w;
    double c[n], d[n];
    dif=fabs(x-xa[0]);
    for(i=0; i<n; i++)
    {
        if((dift=fabs(x-xa[i]))<dif)
        {
            ns=i;
            dif=dift;
        }
        c[i]=ya[i];
        d[i]=ya[i];
    }
    y=ya[ns--];
    for(m=1; m<n; m++)
    {
        for(i=0; i<n-m; i++)
        {
            ho=xa[i]-x;
            hp=xa[i+m]-x;
            w=c[i+1]-d[i];
            if((den=ho-hp)==0.0) std::cout << "Error in routine polint " << std::endl;
            den=w/den;
            d[i]=hp*den;
            c[i]=ho*den;
        }
        y+=(dy=(2*(ns+1) < (n-m) ? c[ns+1] : d[ns--]));
    }
}

//3D interpolation
void TMD::polin3(double x1a[], double x2a[], double x3a[], double ya[][1][4], int m, int n, int o, double x1, double x2, double x3, double& y, double& dy)
{
    const int nmax=10;
    const int mmax=5;
    const int pmax=10;

    double ymtmp[mmax], yntmp[nmax], yptmp[pmax];

    for(int j=0; j<m; j++)
    {
        for(int k=0; k<n; k++)
        {
            for(int l=0; l<o; l++)
            {
                yptmp[l]=ya[j][k][l];
            }
            polint(x3a,yptmp,o,x3,yntmp[k],dy);
        }
        polint(x2a,yntmp,n,x2,ymtmp[j],dy);
    }
    polint(x1a,ymtmp,m,x1,y,dy);
}

